(game-module "gettysburg"
  (title "Gettysburg")
  (blurb "The Battle of Gettysburg, 1-4 July 1863")
  (variants
    (see-all true)
    ("Day/Night" eval (world (day-length 24)))
    )
  )

(unit-type infantry)
(unit-type cavalry)
(unit-type artillery (image-name "cannon"))
(unit-type supply-train (image-name "wagon"))

(define inf infantry)
(define cav cavalry)
(define arty artillery)

(terrain-type clear (image-name "straw") (char "+"))
(terrain-type rough (image-name "mountains") (char "^"))
(terrain-type light-woods (char "%"))
(terrain-type orchard)
(terrain-type woods (image-name "forest") (char "%"))
(terrain-type town (image-name "urban") (char "G"))
(terrain-type stream (image-name "water") (subtype border))
(terrain-type ravine (image-name "gully") (subtype border))
(terrain-type trail (subtype connection))
(terrain-type road (subtype connection))

(add t* elevation-min 0)
(add t* elevation-max 100)

(set grid-color "gray")

;;; Static relationships.

(add t* capacity 3)

(table unit-size-in-terrain
  (u* t* 1)
  (inf road 10)
  (supply-train t* 0)
  )

;(add u* possible-sides (not "independent"))

;;; Actions.

(add u* acp-per-turn (8 16 8 8))

;;; Movement.

(add u* speed  (8 16 8 8))

(table mp-to-enter-terrain
  (u* t* 1)
  (u* rough 99)
  (inf rough 2)
  ((cav arty) woods 4)
  ((inf cav) stream 0)
  ((cavalry arty) road 0)
  )

(table mp-to-leave-terrain
  (u* t* 1)
  (u* rough 99)
  (inf rough 2)
  ((cav arty) woods 4)
  ((cavalry arty) road 0)
  )

(table mp-to-traverse
  ((arty cavalry) road (2 1))
  (supply-train (trail road) (2 1))
  )

;;; Combat.

(add u* hp-max 8)

(table acp-to-attack
  (u* u* 4))

(table acp-to-defend
  (u* u* 4))

(table hit-chance
  (u* u* 50)
  )

(table damage
  (u* u* 4)
  )

(add arty range 5)  ;  (5 or 3 - need two types?)

(add arty acp-to-fire 8)

(table capture-chance
  (u* arty 30)
  )

;;; The world.

(world 125000
;  (day-length 24) ; is a variant
  )

(area 50 36)
(area (terrain
  "50a"
  "aea2e5ae5a2e3ae28a"
  "ae8a2e5aea2e2ae7ae18a"
  "11ae5ae2ae2ae7ae18a"
  "10a2e38a"
  "28ae2ae18a"
  "13ad6ae8a3e18a"
  "6a2e5aed5ae3ae25a"
  "14ae6ae3ad6a2e16a"
  "4ae2ae2ae3ae12a2e4ae16a"
  "5aeae2aea2ead11a2e21a"
  "10aead2ae2a3f6a3e8ae11a"
  "7ae2a2e4ae2a2fe5a3e8a2e10a"
  "7ae3ae4ae10a2e9a3e9a"
  "7a2e2aead3ad6ae2a2ead4ae14a"
  "9a2e2ad3ae6a2ea3e20a"
  "8ad4ae3ae6a3ea3e19a"
  "14ae2ae3ac4aea3eae17a"
  "15a3e5aea7eae16a"
  "13ad2aeae5ae2a2ea2e2ae3a4e8a"
  "12a2e3ae13ae10ae7a"
  "11ae2ae2ae2ad3aea2eae3ae16a"
  "11aea3e2ae10ae3ae5ae10a"
  "11ae7a2d3a2e3ae3ae4a3e9a"
  "22a5ea3e10ae8a"
  "14aeaea2ead2e5a3eae16a"
  "14aeae3ae2ae3c6ae8a3e5a"
  "14ae6ae2ae2c7aeae6a3e4a"
  "21ae2a4e6ae15a"
  "21ad6e22a"
  "18a3e2a5e9ae2a3e7a"
  "19ae4a2e2aead10a3e6a"
  "18a3e7a2e20a"
  "19a2e3a3ea2e20a"
  "25a2e23a"
  "50a"
))
(area (aux-terrain stream
  "50a"
  "6agq7acy33a"
  "6agL8ahq32a"
  "6acT8agL32a"
  "7ahq7acXi31a"
  "7acXi7ab?y30a"
  "8ab?y8ahq29a"
  "10ahq7acT29a"
  "10acT8ap}4aem22a"
  "11ady7adU<3agM<21a"
  "12ahq7ady3agL22a"
  "12agL8ahq2agL22a"
  "12agL8acT2agL22a"
  "12agL9adyagL22a"
  "12agL10adygL22a"
  "12agL11ad:L22a"
  "12acT12ahL22a"
  "13ahq11agL22a"
  "13agL11acT22a"
  "13agL12ady21a"
  "13acTgq11ady20a"
  "14ahwL12ady19a"
  "10ami2acZL13ady18a"
  "10ab?y2ahL14ahq17a"
  "12ad}igL14acT17a"
  "13abCwL15ahqae14a"
  "14agNT15acXicT13a"
  "14agLhq14aenKqhq12a"
  "14acTgL15a?YDgL12a"
  "15ad:T16abC:L12a"
  "16ab?y12ac}2moM<12a"
  "18ahq12ab=CYH2m11a"
  "18agL14acU3=<10a"
  "18agL15adq13a"
  "18acL30a"
  "50a"
))
(area (aux-terrain ravine
  "50a"
  "7agq41a"
  "7agL14ai26a"
  "7acT14ad}3agq20a"
  "8ahq14ab<3a<20a"
  "9a<40a"
  "50a"
  "50a"
  "50a"
  "35ai14a"
  "35ady13a"
  "34agqdy12a"
  "18ae15agLab12a"
  "18agL14agL14a"
  "18agL14acL14a"
  "18agL30a"
  "19a<14agq14a"
  "34agL4ae9a"
  "34agL4acL8a"
  "34acT4ae9a"
  "35ahqeiaoL8a"
  "35agLgMab<8a"
  "36a<a<11a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
))
(area (aux-terrain trail
  "50a"
  "50a"
  "50a"
  "21acu27a"
  "23a@3ac}21a"
  "24a@3aj>u19a"
  "25a>uaj2a>u17a"
  "27a@j4a@4ai11a"
  "28aE5a@3aj11a"
  "27akr6a@2aj11a"
  "27aj8a@aj11a"
  "27aj9a@j11a"
  "18ai8af10aE11a"
  "18aj9aD9aj11a"
  "18aj9aj9aj11a"
  "18ab9aj9aj11a"
  "28af9aj11a"
  "7ae21aD8af11a"
  "8aD20aj9aD10a"
  "8af20aj9aj10a"
  "9aD18akr9aj10a"
  "9af18aj10aj10a"
  "10a>u12ak3sv10aj10a"
  "12a@7acu2aj4aD9af10a"
  "13a>s2{su3a>uj4an10aD9a"
  "15a2j2a@4a?suakr@6ai2aj9a"
  "15a2f3a>q5a>r2a@5aj2aj9a"
  "16a2D9acsu2a@4aj2ab9a"
  "16a2j12a>ua@3aj12a"
  "16ajn14a>sP2aj12a"
  "14acstr@2ae13a>wr12a"
  "19a@2a@14a@12a"
  "20a@2a@7aksu4a@11a"
  "21a<2a>6sr2a>4sL10a"
  "50a"
  "50a"
))
(area (aux-terrain road
  "50a"
  "7ae5aiai3ai10aksq17a"
  "8a>u3afaj3aj8aksr19a"
  "acu7a@3a@f3aj7akr21a"
  "3a>u6a@3a@D2aj5aksr22a"
  "5a>u5a>u2aE2aj4akr24a"
  "7a>u5a@af2aj4aj25a"
  "9a>u4a@aDaj3akr25a"
  "11a>u3a@faj2akr26a"
  "13a>u2a@Djakr27a"
  "15a>uaAnkr28a"
  "17a>q=?2su26a"
  "15ak3syi3a>su23a"
  "13aksr3a2f6a>su20a"
  "12akr6aDH8a>3su15a"
  "10aksr7apr@12a>3su10a"
  "8aksr9aj@a@16a>2su6a"
  "6aksr11ajaDa@19a>3sqa"
  "4aksr13ajaf2a@24a"
  "3acr15aj2a@2a@23a"
  "20aj3a@2a@22a"
  "20aj4aD2a>su19a"
  "20aj4af5a@18a"
  "20aj5aD5a>u16a"
  "20aj5af7a>u14a"
  "20af6aD8a>u12a"
  "21aD5aj10a>u10a"
  "21aj5af12a>u8a"
  "21aj6a@13a>u6a"
  "21aj7aD14a>u4a"
  "21aj7af16a>u2a"
  "21aj8aD17a<a"
  "21aj8af19a"
  "21aj9aD18a"
  "21ab9ab18a"
  "50a"
))
(area (features (
   (17 "ridge" "Seminary")
   (16 "town" "Gettysburg")
   (15 "hill" "Barlow's")
   (14 "hill" "Granite")
   (13 "hill" "Oak")
   (12 "hill" "Benner's")
   (11 "hill" "Wolf")
   (10 "hill" "Culp's")
   (9 "hill" "Power's")
   (8 "hill" "Cemetery")
   (7 "hill" "Little Round Top")
   (6 "hill" "Big Round Top")
   (5 "ridge" "Cress")
   (4 "ridge" "Warfield")
   (3 "ridge" "Cemetery")
   (2 "ridge" "McPherson's")
   (1 "ridge" "Herr")
  )
  "50a"
  "50a"
  "50a"
  "33ao16a"
  "50a"
  "50a"
  "8ab41a"
  "8a2b40a"
  "7a3b40a"
  "7a3b3ac36a"
  "7a3b3ac36a"
  "7a2b4a2c3a3q3am25a"
  "8ab5ac4a2q29a"
  "8ab5ac35a"
  "8ab12ad28a"
  "8ab12aidak25a"
  "9ab11a2d6al20a"
  "21a2d27a"
  "21a2d27a"
  "22ad27a"
  "23ad26a"
  "24ad2ad22a"
  "25ad24a"
  "26ad23a"
  "25ab24a"
  "50a"
  "26ah23a"
  "26ah23a"
  "50a"
  "26ag23a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
))
(area (elevations
  "50a"
  "a5ba3bc12a6b21a"
  "a5ba2babc12a5b21a"
  "a2b2aba2babc12a5b21a"
  "a2b5a2babc11a2b24a"
  "ab6a2b2a2b10a2b24a"
  "8ab3a2b10a2b24a"
  "8a2b3ab10a2b24a"
  "7a3b3a2b9a2b24a"
  "7a3b3a2b9a2b24a"
  "7a3b3abab8a2b24a"
  "7a2b4abab8ab25a"
  "8ab5abab7ab25a"
  "8ab5abab33a"
  "8ab5ab2ab3ac28a"
  "8ab8ab3a2c27a"
  "9ab7ab3a2c27a"
  "21a2c27a"
  "21a2b27a"
  "22a2b26a"
  "23ab26a"
  "27ab22a"
  "25ab24a"
  "26ab23a"
  "25ab24a"
  "50a"
  "26ac23a"
  "26ac23a"
  "50a"
  "26ac23a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
))
#|
(area (features (
   (1 "ridge" "Herr")
   (2 "ridge" "McPherson's")
   (3 "ridge" "Cemetery")
   (4 "ridge" "Warfield")
   (5 "ridge" "Cress")
   (6 "hill" "Big Round Top")
   (7 "hill" "Little Round Top")
   (8 "hill" "Cemetery")
   (9 "hill" "Power's")
   (10 "hill" "Culp's")
   (11 "hill" "Wolf")
   (12 "hill" "Benner's")
   (13 "hill" "Oak")
   (14 "hill" "Granite")
   (15 "hill" "Barlow's")
   (16 "town" "Gettysburg")
   (17 "ridge" "Seminary")
  )
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
  "8ab41a"
  "8a2b40a"
  "7a3b40a"
  "7a3b3ac36a"
  "7a3b3ac36a"
  "7a2b4a2c3a3e29a"
  "8ab5ac4a2e29a"
  "8ab5ac35a"
  "8ab41a"
  "8ab41a"
  "9ab40a"
  "50a"
  "50a"
  "50a"
  "50a"
  "27ad22a"
  "50a"
  "50a"
  "25ab24a"
  "50a"
  "50a"
  "50a"
  "50a"
  "26ac23a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
))
(area (elevations
  "50a"
  "a5ba3bc39a"
  "a5ba2babc38a"
  "a2b2aba2babc38a"
  "a2b5a2babc37a"
  "ab6a2b2a2b36a"
  "8ab3a2b36a"
  "8a2b3ab36a"
  "7a3b3a2b35a"
  "7a3b3a2b35a"
  "7a3b3abab34a"
  "7a2b4abab34a"
  "8ab5abab33a"
  "8ab5abab33a"
  "8ab5ab2ab3ac28a"
  "8ab8ab3a2c27a"
  "9ab7ab3a2c27a"
  "21a2c27a"
  "21a2b27a"
  "22a2b26a"
  "23ab26a"
  "27ab22a"
  "25ab24a"
  "26ab23a"
  "25ab24a"
  "50a"
  "26ac23a"
  "26ac23a"
  "50a"
  "26ac23a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
  "50a"
))
|#

(side 1 (name "US") (adjective "Union")
  (emblem-name "flag-usa") (names-locked true))

(side 2 (name "CSA") (adjective "Confederate")
  (emblem-name "flag-csa") (names-locked true))

(set sides-min 2)
(set sides-max 2)

#|  ; McPherson's scenario
(infantry 13 25 1  (n "1 Meredith"))
(infantry 14 27 1  (n "2 Cutler"))
(infantry 13 29 1  (n "3 Paul"))
(infantry 13 28 1  (n "4 Baxter"))
(infantry 14 24 1  (n "5 Rowley"))
(infantry 13 26 1  (n "6 Stone"))
(artillery 14 26 1  (n "7 Wainwright a"))
(artillery 14 24 1  (n "8 Wainwright b"))
(infantry 14 24 1  (n "5 Rowley"))
(infantry 13 26 1  (n "6 Stone"))
|#

(infantry -21 -1 1 (n "Meredith") (cp -3))
(infantry -21 -1 1 (n "Cutler") (cp -3))
(infantry -21 -1 1 (n "Paul") (cp -4))
(infantry -21 -1 1 (n "Baxter") (cp -4))
(infantry -3 -16 1 (n "Rowley") (cp -6))
(infantry -3 -16 1 (n "Stone") (cp -6))
(artillery -21 -1 1 (n "Wainwright a") (cp -5))
(artillery -21 -1 1 (n "Wainwright b") (cp -5))
(inf -31 -1 1 (n "Cross") (cp -18))
(inf -31 -1 1 (n "Kelly") (cp -18))
(inf -31 -1 1 (n "Zook") (cp -18))
(inf -31 -1 1 (n "Brooke") (cp -19))
(inf -31 -1 1 (n "Harrow") (cp -19))
(inf -31 -1 1 (n "Webb") (cp -19))
(inf -31 -1 1 (n "Hall") (cp -20))
(inf -31 -1 1 (n "Carroll") (cp -20))
(inf -31 -1 1 (n "Smyth") (cp -20))
(inf -31 -1 1 (n "Willard") (cp -21))
(arty -31 -1 1 (n "Hazard a") (cp -21))
(arty -31 -1 1 (n "Hazard b") (cp -21))
(inf -21 -1 1 (n "Graham") (cp -12))
(inf -21 -1 1 (n "Ward") (cp -12))
(inf -21 -1 1 (n "de Trobriand") (cp -27))
(inf -21 -1 1 (n "Carr") (cp -13))
(inf -21 -1 1 (n "Brewster") (cp -13))
(inf -21 -1 1 (n "Burling") (cp -27))
(arty -21 -1 1 (n "Rand a") (cp -12))
(arty -21 -1 1 (n "Rand b") (cp -14))
(inf -43 -19 1 (n "Tilton") (cp -27))
(inf -43 -19 1 (n "Schweitzer") (cp -27))
(inf -43 -19 1 (n "Vincent") (cp -27))
(inf -43 -19 1 (n "Day") (cp -28))
(inf -43 -19 1 (n "Burbank") (cp -28))
(inf -43 -19 1 (n "Weed") (cp -28))
(inf -43 -19 1 (n "McCandless") (cp -31))
(inf -43 -19 1 (n "Fisher") (cp -32))
(arty -43 -19 1 (n "Martin a") (cp -29))
(arty -43 -19 1 (n "Martin b") (cp -29))
(inf -48 -4 1 (n "Torbert") (cp -34))
(inf -48 -4 1 (n "Bartlett") (cp -34))
(inf -48 -4 1 (n "Russell") (cp -34))
(inf -48 -4 1 (n "Grant") (cp -35))
(inf -48 -4 1 (n "Neill") (cp -35))
(inf -48 -4 1 (n "Shaler") (cp -35))
(inf -48 -4 1 (n "Eustis") (cp -36))
(inf -48 -4 1 (n "Wheaton") (cp -36))
(arty -48 -4 1 (n "Tompkins a") (cp -37))
(arty -48 -4 1 (n "Tompkins b") (cp -37))
(arty -48 -4 1 (n "Tompkins c") (cp -37))
(inf -21 -1 1 (n "von Gilsa") (cp -6))
(inf -21 -1 1 (n "Ames") (cp -6))
(inf -31 -1 1 (n "Coster") (cp -8))
(inf -31 -1 1 (n "Smith") (cp -8))
(inf -31 -1 1 (n "Schimmelfenning") (cp -6))
(inf -31 -1 1 (n "Krzyzanowski") (cp -6))
(arty -31 -1 1 (n "Osborn a") (cp -7))
(arty -31 -1 1 (n "Osborn b") (cp -7))
(inf -48 -4 1 (n "McDougall") (cp -10))
(inf -48 -4 1 (n "Ruger") (cp -10))
(inf -48 -4 1 (n "Candy") (cp -10))
(inf -48 -4 1 (n "Kane") (cp -11))
(inf -48 -4 1 (n "Greene") (cp -11))
(arty -48 -4 1 (n "Muhlenburg a") (cp -12))
(arty -48 -4 1 (n "Muhlenburg b") (cp -12))
(inf -21 -1 1 (n "Stannard") (cp -11))
(inf -48 -4 1 (n "Lockwood") (cp -25))
(arty -31 -1 1 (n "Ransom") (cp -24))
(arty -31 -1 1 (n "McGilvey") (cp -28))
(arty -31 -1 1 (n "Taft") (cp -24))
(arty -31 -1 1 (n "Huntington") (cp -25))
(arty -31 -1 1 (n "Fitzhugh") (cp -25))
(cav 20 24 1 (n "Gamble"))
(cav 20 23 1 (n "Devin"))
(cav -43 -19 1 (n "McIntosh") (cp -36))
(cav -43 -19 1 (n "Gregg") (cp -36))
(cav -43 -19 1 (n "Farnsworth") (cp -57))
(cav -43 -19 1 (n "Custer") (cp -57))
(supply-train -48 -4 1 (cp -16))

(inf -1 -32 2 (n "Anderson") (cp -18))
(inf -1 -32 2 (n " Benning") (cp -18))
(inf -1 -32 2 (n "Law") (cp -31))
(inf -1 -32 2 (n "Robertson") (cp -18))
(arty -1 -32 2 (n "Henry") (cp -19))
(inf -1 -32 2 (n "Barksdale") (cp -19))
(inf -1 -32 2 (n "Kershaw") (cp -19))
(inf -1 -32 2 (n "Semmes") (cp -20))
(inf -1 -32 2 (n "Wofford") (cp -20))
(arty -1 -32 2 (n "Cabell") (cp -20))
(inf -1 -32 2 (n "Armisted") (cp -36))
(inf -1 -32 2 (n "Garnett") (cp -36))
(inf -1 -32 2 (n "Kemper") (cp -36))
(arty -1 -32 2 (n "Dearing") (cp -37))
(inf -1 -32 2 (n "Alexander") (cp -21))
(inf -1 -32 2 (n "Eshleman") (cp -21))
(infantry -19 -34 2 (n "Gordon") (cp -9))
(infantry -19 -34 2 (n "Hays") (cp -9))
(infantry -19 -34 2 (n "Hoke") (cp -9))
(infantry -19 -34 2 (n "Smith") (cp -10))
(artillery -19 -34 2 (n "H. Jones") (cp -10))
(inf -1 -32 2 (n "Jones") (cp -13))
(inf -1 -32 2 (n "Nicholls") (cp -13))
(inf -1 -32 2 (n "Steuart") (cp -13))
(inf -1 -32 2 (n "Walker") (cp -14))
(arty -1 -32 2 (n "Latimer") (cp -14))
(infantry -7 -34 2  (n "Daniel") (cp -7))
(inf -7 -34 2 (n "Doles") (cp -7))
(inf -7 -34 2 (n "Iverson") (cp -7))
(inf -7 -34 2 (n "O'Neal") (cp -8))
(infantry -7 -34 2  (n "Ramseur") (cp -8))
(arty -1 -32 2 (n "Carter") (cp -8))
(arty -1 -32 2 (n "Dance") (cp -15))
(arty -1 -32 2 (n "Nelson") (cp -15))
(inf -1 -32 2 (n "Mahone") (cp -12))
(inf -1 -32 2 (n "Perry") (cp -12))
(inf -1 -32 2 (n "Posey") (cp -12))
(inf -1 -32 2 (n "Wilcox") (cp -13))
(inf -1 -32 2 (n "Wright") (cp -13))
(arty -1 -32 2 (n "J. Lane") (cp -13))
(inf 5 30 2 (n "Archer"))
(inf -1 -32 2 (n "Brockenbrough") (cp -4))
(inf 5 30 2 (n "Davis"))
(inf -1 -32 2 (n "Pettigrew") (cp -4))
(inf -1 -32 2 (n "J. Garnet") (cp -4))
(inf -1 -32 2 (n "Lane") (cp -7))
(inf -1 -32 2 (n "Perrin") (cp -7))
(inf -1 -32 2 (n "Scales") (cp -7))
(infantry -1 -32 2  (n "Thomas") (cp -8))
(artillery -1 -32 2  (n "Poague") (cp -8))
(artillery -1 -32 2  (n "McIntosh") (cp -5))
(artillery -1 -32 2  (n "Pegram") (cp -3))
(cav -19 -34 2 (n "Hampton") (cp -33))
(cav -19 -34 2 (n "Jenkins") (cp -10))
(cav -19 -34 2 (n "F. Lee") (cp -33))
(cav -19 -34 2 (n "W. Lee") (cp -33))

(supply-train -1 -32 2 (cp -16))

(scorekeeper (do last-side-wins))

(set calendar ("usual" "hour"))

(set initial-date "06 1 Jul 1863")

(set initial-day-part -6)

(game-module (design-notes (
  "This is a brigade-level simulation, inspired by the game described in"
  "the July-Aug 1992 issue of Command."
  ""
  "The scale is 5 hexes/mile, 1 hour/turn."
  )))

