/* Main program of ImFam. */

#ifdef THINK_C
#include <MacHeaders>
#else /* probably MPW */

#endif

/* (should fix these wired pathnames eventually) */

#include "::src:config.h"
#include "::src:misc.h"
#include "::src:lisp.h"

#include "::mac:macimf.h"

#define MAXIMAGES 1000

/* Definitions for the menus. */

#define mApple 128

#define mFile 129

#define miFileOpenImf 1
#define miFileOpenResources 2
/* 3 */
#define miFileSaveImf 4
#define miFileSaveResources 5
/* 6 */
#define miFileQuit 7

#define mEdit 130

#define mView 131
#define miView4x4 1
#define miView8x8 2
#define miView16x16 3
#define miView32x32 4
/* 5 */
#define miViewColor 6
/* 7 */
#define miViewAsUnit 8
#define miViewAsTerrain 9
#define miViewAsEmblem 10
#define miViewWithUnit 11
#define miViewWithTerrain 12
#define miViewWithEmblem 13
/* 14 */
#define miViewIcons 15
#define miViewTiles 16
#define miViewNames 17

#define pascalify(STR,OUT) \
  sprintf(OUT, " %s", STR);  OUT[0] = strlen(STR);

#define hextoi(c) (((c) >= '0' && (c) <= '9') ? ((c) - '0') : ((c) - 'a' + 10))

/* Variables tweaked by menu items. */

int showcolor = 1;

int varyunit = 1;
int varyterrain = 0;
int varyemblem = 0;

int withunit = 0;
int withterrain = 0;
int withemblem = 0;

int selecticons = 1;
int selecttiles = 1;
int viewnames = 1;

/* Pointers to the image families being held constant for display. */

ImageFamily *constterrain = NULL;

ImageFamily *constunit = NULL;

ImageFamily *constemblem = NULL;

int iw = 16, ih = 16;

int usecolor;

int useWNE;

char spbuf[1000];
char tmpbuf[1000];

Str255 tmpstr;

int nextimageid = 1000;

int nextsicnid = 1000;

int nexticonid = 1000;

/* Pointer to storage for all the image families. */

ImageFamily **images;

int numimages = 0;

ImageFamily *selectedimf = NULL;

int selectedn = 0;

ImageColor **colors;

int numcolors = 0;

WindowPtr imagewin = NULL;

Rect dragrect = { 0, 0, 1000, 1000 };
Rect sizerect;

int toplineh = 16;

ControlHandle vscrollbar = nil;

Rect vscrollrect;

int sbarwid = 15;

int numvisrows = 0;

int firstvisrow = 0;

int winwidth, winheight, rows, cols;

int eltw, elth;

char *copy_string();
ImageFamily *get_imf();
ImageFamily *find_imf();
ImageColor *get_imc();
ImageColor *find_imc();

main()
{
	SysEnvRec se;
	int i;
	Handle menubar;
	MenuHandle menu;
	WindowPtr win;
	Rect r;
	RgnHandle cursorRgn;
	Boolean gotevent;
	EventRecord	event;
	Point mouse;
	DialogPtr dialog;
	short itemhit;

	InitGraf(&thePort);
	InitFonts();
	FlushEvents(everyEvent, 0);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(NULL);
	InitCursor();

	SysEnvirons(2, &se);
	usecolor = se.hasColorQD;
	
	menubar = GetNewMBar(128);
	SetMenuBar(menubar);
	/* Add the DAs etc as usual. */
	if ((menu = GetMHandle(mApple)) != nil) {
		AddResMenu(menu, 'DRVR');
	}
	DrawMenuBar();

	init_lisp();
	numimages = 0;

	images = (ImageFamily **) xmalloc(MAXIMAGES * sizeof(ImageFamily *));
	colors = (ImageColor **) xmalloc(MAXIMAGES * sizeof(ImageColor *));

	if (usecolor) {
		imagewin = GetNewCWindow(128, NULL, (WindowPtr) -1L);
	} else {
		imagewin = GetNewWindow(128, NULL, (WindowPtr) -1L);
	}
	vscrollrect = imagewin->portRect;
	vscrollrect.left = vscrollrect.right - sbarwid;  vscrollrect.top += toplineh - 1;
	vscrollrect.right += 1;  vscrollrect.bottom -= sbarwid - 1;
	vscrollbar =
		NewControl(imagewin, &vscrollrect, "\p", 1, 0, 0, 100, scrollBarProc, 0L);
	ShowWindow(imagewin);

/*	dragrect = screenBits.bounds; */
	dragrect.left += 30;
	dragrect.right -= 30;
	dragrect.bottom -= 30;
	sizerect.top = 50;
	sizerect.left = 50;
	sizerect.bottom = screenBits.bounds.bottom - screenBits.bounds.top;
	sizerect.right  = screenBits.bounds.right  - screenBits.bounds.left;

	useWNE = (NGetTrapAddress(0x60, ToolTrap) != NGetTrapAddress(0x9f, ToolTrap));
	/* Pass WNE an empty region the 1st time thru. */
	cursorRgn = NewRgn();
	do {
		/* Use WaitNextEvent if it is available. */
		if (useWNE) {
			GetGlobalMouse(&mouse);
/*			adjust_cursor(mouse, cursorRgn); */
			gotevent = WaitNextEvent(everyEvent, &event, 0L, cursorRgn);
		} else {
			SystemTask();
			gotevent = GetNextEvent(everyEvent, &event);
		}
		if (gotevent) {
			/* make sure we have the right cursor before handling the event */
/*			adjust_cursor(event.where, cursorRgn); */
			do_event(&event);
		}
	} while (1);
}

GetGlobalMouse(mouse)
Point *mouse;
{
	EventRecord	event;
	
	OSEventAvail(0, &event);	/* we aren't interested in any events */
	*mouse = event.where;				/* just the mouse position */
}

/* Change the cursor to reflect the context. */

adjust_cursor(mouse, region)
Point mouse;
RgnHandle region;
{
	/* Usually we'll want the standard arrow cursor. */
	SetCursor(&arrow);
}

do_event(event)
EventRecord *event;
{
	short part, err;
	WindowPtr window;
	Boolean hit;
	char key;
	Point pnt;
	long winsize;
	GrafPtr oldport;

	switch (event->what) {
		case mouseDown:
			part = FindWindow(event->where, &window);
			switch (part) {
				case inMenuBar:
					adjust_menus();
					do_menu_command(MenuSelect(event->where));
					break;
				case inSysWindow:
					SystemClick(event, window);
					break;
				case inContent:
					if (window != FrontWindow()) {
						SelectWindow(window);
						/* We just want to discard the event, since clicks in a
						   windows are sometimes irreversible actions. */
						adjust_menus();
					} else {
						handle_mouse_click(event->where, event->modifiers);
					}
					break;
				case inDrag:
					DragWindow(window, event->where, &dragrect);
					break;
				case inGrow:
					winsize = GrowWindow(window, event->where, &sizerect);
					if (winsize != 0) {
						GetPort(&oldport);
						SetPort(window);
						EraseRect(&window->portRect);
						SizeWindow(window, LoWord(winsize), HiWord(winsize), 1);
						MoveControl(vscrollbar, LoWord(winsize) - sbarwid, toplineh);
						SizeControl(vscrollbar, sbarwid + 1, HiWord(winsize) - toplineh - sbarwid + 1 + 1);
						InvalRect(&window->portRect);
						SetPort(oldport);
					}
					break;
				case inZoomIn:
				case inZoomOut:
					break;
				case inGoAway:  /* (should probably disable?) */
					/* should make some intelligent decisions about what to dispose
						and what to keep */
					HideWindow(window);
					break;
			}
			break;
		case mouseUp:
			part = FindWindow(event->where, &window);
			switch (part) {
				case inContent:
					if (0 /* up in diff window than down? */) {
					} else {
					}
					break;
			}
			break;
		case keyDown:
		case autoKey:
			key = event->message & charCodeMask;
			/* Check for menukey equivalents. */
			if (event->modifiers & cmdKey) {
				if (event->what == keyDown) {
					adjust_menus();
					do_menu_command(MenuKey(key));
				}
			} else {
				if (event->what == keyDown) {
					/* Random keypress, interpret it. */
				}
			}
			break;
		case activateEvt:
			break;
		case updateEvt:
			if (imagewin == ((WindowPtr) event->message)) {
				update_image_window();
			}
			break;
		case diskEvt:
			/*	Call DIBadMount in response to a diskEvt, so that the user can format
				 a floppy. (from DTS Sample) */
			if (HiWord(event->message) != noErr) {
				SetPt(&pnt, 50, 50);
				err = DIBadMount(pnt, event->message);
			}
			break;
#if 0
		case kOSEvent:
		/*	1.02 - must BitAND with 0x0FF to get only low byte */
			switch ((event->message >> 24) & 0x0FF) {		/* high byte of message */
				case kSuspendResumeMessage:		/* suspend/resume is also an activate/deactivate */
					gInBackground = (event->message & kResumeMask) == 0;
					DoActivate(FrontWindow(), !gInBackground);
					break;
			}
			break;
#endif
		default:
			break;
	}
}

/* Decipher and do a menu command. */

do_menu_command(which)
long which;
{
	short menuid, menuitem;
	short itemHit;
	Str255 daname;
	short daRefNum;
	Boolean handledbyda;
	WindowPtr win;
	short ditem;
	int i;

	menuid = HiWord(which);
	menuitem = LoWord(which);
	switch (menuid) {
		case mApple:
			switch (menuitem) {
				case 1:
/*					win = GetNewDialog(dAbout, NULL, (DialogPtr) -1L);
					ShowWindow(win);
					ModalDialog(NULL, &ditem);
					DisposDialog(win); */
					break;
				default:
					GetItem(GetMHandle(mApple), menuitem, daname);
					daRefNum = OpenDeskAcc(daname);
			}
			break;
		case mFile:
			switch (menuitem) {
				case miFileOpenImf:
					open_imf_file();
					force_update();
					break;
				case miFileOpenResources:
					open_resource_file();
					force_update();
					break;
				case miFileSaveImf:
					save_imf_file();
					break;
				case miFileSaveResources:
					save_resource_file();
					break;
				case miFileQuit:
					ExitToShell();
					break;
			}
			break;
		case mEdit:
			/* handledbyda = SystemEdit(menuitem-1); */
			switch (menuitem)  {
/*				case miEditCut:
					break; */
			}
			break;
		case mView:
			switch (menuitem) {
				case miView4x4:
					iw = ih = 4;
					break;
				case miView8x8:
					iw = ih = 8;
					break;
				case miView16x16:
					iw = ih = 16;
					break;
				case miView32x32:
					iw = ih = 32;
					break;
				case miViewColor:
					showcolor = !showcolor;
					break;
				case miViewAsUnit:
					varyunit = 1;
					varyterrain = 0;
					varyemblem = 0;
					break;
				case miViewAsTerrain:
					varyunit = 0;
					varyterrain = 1;
					varyemblem = 0;
					break;
				case miViewAsEmblem:
					varyunit = 0;
					varyterrain = 0;
					varyemblem = 1;
					break;
				case miViewWithUnit:
					withunit = !withunit;
					constunit = selectedimf;
					break;
				case miViewWithTerrain:
					withterrain = !withterrain;
					constterrain = selectedimf;
					break;
				case miViewWithEmblem:
					withemblem = !withemblem;
					constemblem = selectedimf;
					break;
				case miViewIcons:
					selecticons = !selecticons;
					break;
				case miViewTiles:
					selecttiles = !selecttiles;
					break;
				case miViewNames:
					viewnames = !viewnames;
					break;
			}
			force_update();
			break;
	}
	HiliteMenu(0);
}

adjust_menus()
{
	MenuHandle menu;

	if ((menu = GetMHandle(mView)) != nil) {
		CheckItem(menu, miView4x4, (iw == 4));
		CheckItem(menu, miView8x8, (iw == 8));
		CheckItem(menu, miView16x16, (iw == 16));
		CheckItem(menu, miView32x32, (iw == 32));
		if (usecolor) {
			EnableItem(menu, miViewColor);
			CheckItem(menu, miViewColor, showcolor);
		} else {
			DisableItem(menu, miViewColor);
		}
		CheckItem(menu, miViewAsUnit, varyunit);
		CheckItem(menu, miViewAsTerrain, varyterrain);
		CheckItem(menu, miViewAsEmblem, varyemblem);
		if (selectedimf != NULL && !varyunit) {
			EnableItem(menu, miViewWithUnit);
			CheckItem(menu, miViewWithUnit, withunit);
		} else {
			DisableItem(menu, miViewWithUnit);
		}
		if (selectedimf != NULL && !varyterrain) {
			EnableItem(menu, miViewWithTerrain);
			CheckItem(menu, miViewWithTerrain, withterrain);
		} else {
			DisableItem(menu, miViewWithTerrain);
		}
		if (selectedimf != NULL && !varyemblem) {
			EnableItem(menu, miViewWithEmblem);
			CheckItem(menu, miViewWithEmblem, withemblem);
		} else {
			DisableItem(menu, miViewWithEmblem);
		}
		CheckItem(menu, miViewIcons, selecticons);
		CheckItem(menu, miViewTiles, selecttiles);
		CheckItem(menu, miViewNames, viewnames);
	}
}

pascal void
scroll_proc(control, code)
ControlHandle control;
short code;
{
	int curvalue, jump;

	curvalue = GetCtlValue(control);
	switch (code) {
		case inPageDown:
			jump = (numvisrows > 2 ? numvisrows - 2 : 1);
			break;
		case inDownButton:
			jump = 1;
			break;
		case inPageUp:
			jump = - (numvisrows > 2 ? numvisrows - 2 : 1);
			break;
		case inUpButton:
			jump = -1;
			break;
		default:
			jump = 0;
			break;
	}
	curvalue += jump;
	SetCtlValue(control, curvalue);
}

handle_mouse_click(mouse, mods)
Point mouse;
int mods;
{
	int row, col, n;
	ControlHandle control;
	short part, value, oldvalue;

	SetPort(imagewin);
	GlobalToLocal(&mouse);
	part = FindControl(mouse, imagewin, &control);
	if (control == vscrollbar) {
		oldvalue = GetCtlValue(vscrollbar);
		switch (part) {
			case inThumb:
				part = TrackControl(control, mouse, NULL);
				break;
			default:
				part = TrackControl(control, mouse, &scroll_proc);
				break;
		}
		firstvisrow = GetCtlValue(vscrollbar);
		if (oldvalue != firstvisrow) {
			force_update();
		}
	} else {
		col = mouse.h / eltw;
		row = (mouse.v - toplineh) / elth + firstvisrow;
		n = col * rows + row;
		if (n < numimages) {
			if (images[n] != selectedimf) {
				invert_selected_imf();
				selectedimf = images[n];
				selectedn = n;
				invert_selected_imf();
				if ((mods & cmdKey) && withterrain) {
					constterrain = selectedimf;
					force_update();
				}
			}
		} else {
			invert_selected_imf();
			selectedimf = NULL;
		}
		draw_topline();
	}
}

force_update()
{
	GrafPtr oldport;

	GetPort(&oldport);
	SetPort(imagewin);
	EraseRect(&imagewin->portRect);
	InvalRect(&imagewin->portRect);
	SetPort(oldport);
}

/* The comparison function for the image list just does "strcmp" order and *insists*
   that all image families be named and named uniquely. */

image_name_compare(im1, im2)
ImageFamily **im1, **im2;
{
	return strcmp((*im1)->name, (*im2)->name);
}

/* be able to choose a file eventually */

open_imf_file()
{
	FILE *fp;

	Point pnt;
	/* SFTypelist typelist; */
	long typelist[4];
	SFReply reply;
	int frefnum;
	Str255 filename;
	Obj *form;
	int startlineno = 0, endlineno = 0;

	/* Gotta be somewhere... */
	SetPt(&pnt, 100, 100);
	typelist[0] = 'TEXT';
	SFGetFile(pnt, "\p", NULL, 1, &typelist, NULL, &reply);
	if (reply.good) {
		if ((fp = fopen("lib.imf", "r")) != NULL) {
			while ((form = read_form(fp, &startlineno, &endlineno)) != lispeof) {
				interp_imf_form(form);
			}
			fclose(fp);
		}
		/* Sort all into alphabetical order. */
		qsort(&(images[0]), numimages, sizeof(ImageFamily *), image_name_compare);
	}
}

interp_imf_form(form)
Obj *form;
{
	ImageFamily *imf;
	ImageColor *imc;
	Obj *rest, *clause, *size, *typ;

	if (equal(car(form), intern_symbol("imf"))) {
		if (stringp(cadr(form))) {
			imf = get_imf(c_string(cadr(form)));
			for (rest = cddr(form); rest != lispnil; rest = cdr(rest)) {
				clause = car(rest);
				if (consp(clause)) {
					interp_image(imf, car(clause), cdr(clause));
				}
			}
		} else {
			/* garbage? */
		}
	} else if (equal(car(form), intern_symbol("palette"))) {
	} else if (equal(car(form), intern_symbol("color"))) {
		if (stringp(cadr(form))) {
			imc = get_imc(c_string(cadr(form)));
			interp_color(imc, cddr(form));
		}
	} else {
		/* warn */
	}
}

interp_image(imf, size, parts)
ImageFamily *imf;
Obj *size, *parts;
{
	int w, h, i;
	char *data;
	Image *img = NULL;
	Obj *rest, *typ, *datalist;
	Handle sicnhandle, iconhandle;

	w = c_number(car(size));  h = c_number(cadr(size));
	if ((img = get_img(imf, w, h)) != NULL) {
		if (equal(car(cddr(size)), intern_symbol("tile"))) img->istile = TRUE;
		for (rest = parts; rest != lispnil; rest = cdr(rest)) {
			typ = car(car(rest));
			datalist = cdr(car(rest));
			if (w == 8 && h == 8) {
				if (equal(typ, intern_symbol("mono"))) {
					data = c_string(car(datalist));
					for (i = 0; i < 8; ++i) {
						img->pat[i] = hextoi(data[2*i]) * 16 + hextoi(data[2*i+1]);
					}
					img->patdefined = TRUE;
				}
			} else if (w == 16 && h == 16) {
				sicnhandle = NewHandle(32);
				memset(*sicnhandle, 0, 32);
				data = c_string(car(datalist));
				for (i = 0; i < 32; ++i) {
					((char *) (*sicnhandle))[i] =
						hextoi(data[2*i]) * 16 + hextoi(data[2*i+1]);
				}
				if (equal(typ, intern_symbol("mono"))) {
					img->monosicn = sicnhandle;
				} else if (equal(typ, intern_symbol("mask"))) {
					img->masksicn = sicnhandle;
				}
			} else if (w == 32 && h == 32) {
				iconhandle = NewHandle(128);
				memset(*iconhandle, 0, 128);
				for (i = 0; i < 128; ++i) {
					if (i % 32 == 0) {
						data = c_string(car(datalist));
						datalist = cdr(datalist);
					}
					((char *) (*iconhandle))[i] =
						hextoi(data[2*(i%32)]) * 16 + hextoi(data[2*(i%32)+1]);
				}
				if (equal(typ, intern_symbol("mono"))) {
					img->monoicon = iconhandle;
				} else if (equal(typ, intern_symbol("mask"))) {
					img->maskicon = iconhandle;
				}
			}
		}
	}
}

interp_color(imc, elts)
ImageColor *imc;
Obj *elts;
{
	imc->r = c_number(car(elts));
	imc->g = c_number(car(cdr(elts)));
	imc->b = c_number(car(cddr(elts)));
}

open_resource_file()
{
	Point pnt;
	/* SFTypelist typelist; */
	long typelist[4];
	SFReply reply;
	int frefnum;
	Str255 filename;

	/* Gotta be somewhere... */
	SetPt(&pnt, 100, 100);
	/* Pick up any sort of file. */
	SFGetFile(pnt, "\p", NULL, -1, &typelist, NULL, &reply);
	if (reply.good) {
		if (OpenResFile(reply.fName) != -1) {
			/* Now that all the resources are available, go through all types of rsrcs
			   that might have useful images. */
			collect_all_resources('XCif');
			collect_all_resources('cicn');
			collect_all_resources('ICON');
			collect_all_resources('SICN');
			collect_all_resources('ppat');
			collect_all_resources('PAT ');
			/* Sort all into alphabetical order. */
			qsort(&(images[0]), numimages, sizeof(ImageFamily *), image_name_compare);
		} else {
			/* should alert */
		}
	}
}

/* Given a resource type, look for and load image families with names of that type. */

collect_all_resources(typ)
ResType typ;
{
    int i, n;
	char *imfname;
	Handle handle;
	short resid;  ResType restype;  Str255 resname;

	n = CountResources(typ);
	for (i = 0; i < n; ++i ) {
		imfname = NULL;
		handle = GetIndResource(typ, i + 1);
		GetResInfo(handle, &resid, &restype, &resname);
		if (resname[0] > 0) {
			resname[resname[0]+1] = '\0';
			imfname = copy_string(resname+1);
		} else {
			/* (should warn about unnamed resources being ignored?) */
		}
		if (imfname != NULL) {
			get_imf(imfname);
		}
	}
}

/* Given a name, find or create an image color with that name. */

ImageColor *
get_imc(name)
char *name;
{
	int i;
	ImageColor *imc = NULL;

	if (name == NULL) return NULL;
	if ((imc = find_imc(name)) == NULL) {
		if (numcolors < MAXIMAGES) {
			if ((imc = (ImageColor *) xmalloc(sizeof(ImageColor))) != NULL) {
				imc->name = name;
				imc->r = imc->g = imc->b = 0;
				load_image_color(imc);
				colors[numcolors++] = imc;
			}
		}
	}
	return imc;
}

/* Find the image color of the given name, if it exists. */

ImageColor *
find_imc(name)
char *name;
{
	int i;

	for (i = 0; i < numcolors; ++i) {
		if (strcmp(name, colors[i]->name) == 0) return colors[i];
	}
	return NULL;
}

/* Write all the images into an imf file. */

save_imf_file()
{
    FILE *ofp;
    int i, n;
	Handle handle;
	short resid;
	ResType restype;
	Str255 resname;

	if ((ofp = fopen("lib.imf", "w")) == NULL) {
		/* make an alert */
		return;
	}
	/* Write out the imf forms of all the image families. */
	for (i = 0; i < numimages; ++i) {
		write_imf(ofp, images[i]);
	}
	fclose(ofp);
}

/* Write out the entire image family. */

write_imf(fp, imf)
FILE *fp;
ImageFamily *imf;
{
	int i;
	Image *img;

	if (imf != NULL && imf->name != NULL) {
		fprintf(fp, "(imf \"%s\"\n", imf->name);
		for (i = 0; i < imf->numsizes; ++i) {
			img = &(imf->images[i]);
			fprintf(fp, " ((%d %d", img->w, img->h);
			if (img->istile) fprintf(fp, " tile");
			fprintf(fp, ")\n");
			if (img->patdefined) write_pattern(fp, &(img->pat));
			/* do color pats eventually */
			if (img->monosicn != nil) write_16x16(fp, "mono", *(img->monosicn));
			if (img->masksicn != nil) write_16x16(fp, "mask", *(img->masksicn));
			if (img->monoicon != nil) write_32x32(fp, "mono", *(img->monoicon));
			if (img->maskicon != nil) write_32x32(fp, "mask", *(img->maskicon));
			if (usecolor && img->colricon != nil) write_cicn(fp, img->colricon);
			fprintf(fp, "  )\n");
		}
		fprintf(fp, " )\n");
	} else {
		fprintf(fp, "; garbage?\n");
	}
}

write_pattern(fp, data)
FILE *fp;
char *data;
{
	int i;
	
	fprintf(fp, "  (mono \"");
	for (i = 0; i < 8; ++i) {
		fprintf(fp, "%02x", (unsigned char) data[i]);
	}
	fprintf(fp, "\")\n");
}

write_16x16(fp, name, data)
FILE *fp;
char *name, *data;
{
	int i;
	
	fprintf(fp, "  (%s \"", name);
	for (i = 0; i < 32; ++i) {
		fprintf(fp, "%02x", (unsigned char) data[i]);
	}
	fprintf(fp, "\")\n");
}

write_32x32(fp, name, data)
FILE *fp;
char *name, *data;
{
	int i, j;
	
	fprintf(fp, "  (%s\n", name);
	for (j = 0; j < 4; ++j) {
		fprintf(fp, "   \"");
		for (i = 0; i < 32; ++i) {
			fprintf(fp, "%02x", (unsigned char) data[32 * j + i]);
		}
		fprintf(fp, "\"\n");
	}
	fprintf(fp, "   )\n");
}

write_cicn(fp, cicnhandle)
FILE *fp;
CIconHandle cicnhandle;
{
	int w, h, i, j;
	Rect bounds;
	char *data;
	PixMap pmap = (*cicnhandle)->iconPMap;

	bounds = pmap.bounds;
	w = bounds.right - bounds.left;  h = bounds.bottom - bounds.top;
	data = pmap.baseAddr;
	fprintf(fp, "  (color (palette) (actual %d %d)\n", w, h);
	for (j = 0; j < h; ++j) {
		fprintf(fp, "   \"");
		for (i = 0; i < w; ++i) {
			fprintf(fp, "%02x",
				((unsigned char) data[((j - bounds.top) * (pmap.rowBytes & 0x3fff)
									  + (i - bounds.left) * pmap.pixelSize) / 8 ]));
		}
		fprintf(fp, "\"\n");
	}
	fprintf(fp, "   )\n");
	fprintf(fp, ";  (mask (actual %d %d)\n", w, h);
	data = (*cicnhandle)->iconMask.baseAddr;
	/* if mask is present */
	for (j = 0; j < h; ++j) {
		fprintf(fp, ";   \"");
		for (i = 0; i < (w + 7) / 8; ++i) {
			fprintf(fp, "%02x", ((unsigned char) data[j * w + i]));
		}
		fprintf(fp, "\"\n");
	}
	fprintf(fp, ";   )\n");
}

/* Write all the images into a resource file. */

/* (should confirm name first, seed with "<loaded file name> Resources") */

int nextcolorid;
int nextimfid;

save_resource_file()
{
    FILE *ifp;
	int refnum, i;
	Handle handle;
	Str255 tmpstr;

	CreateResFile("\plib.imf Resources");
	if ((refnum = OpenResFile("\plib.imf Resources")) >= 0) {
		/* All resource ids should go from 1000 up. */
		nextsicnid = 1000;
		nexticonid = 1000;
		nextcolorid = 1000;
		nextimfid = 1000;
		/* Make resources for named colors. */
		/* (should only do this if resources don't exist already) */
		for (i = 0; i < numcolors; ++i) {
			handle = NewHandle(6);
			((short *) (*handle))[0] = colors[i]->r;
			((short *) (*handle))[1] = colors[i]->g;
			((short *) (*handle))[2] = colors[i]->b;
			pascalify(colors[i]->name, tmpbuf);
			AddResource(handle, 'XCic', nextcolorid++, tmpbuf);
		}
		/* Make resources for image families. */
		for (i = 0; i < numimages; ++i) {
			/* (should make contents then fill in new handle) */
			handle = NewHandle(0);
			pascalify(images[i]->name, tmpbuf);
			AddResource(handle, 'XCif', nextimfid++, tmpbuf);
		}
		CloseResFile(refnum);
	} else {
		/* alert about inability to open */
	}
}

update_image_window()
{
	int row, col, n;
	int namex, namey;
	Rect tmprect;
	GrafPtr oldport;

	BeginUpdate(imagewin);
	GetPort(&oldport);
	SetPort(imagewin);
	EraseRect(&(imagewin->portRect));
	draw_topline();
	eltw = (viewnames ? 100 : iw + 4);  elth = ih + 4;
	/* (should be determined by font) */
	if (elth < 10) elth = 10;
	winwidth = imagewin->portRect.right - imagewin->portRect.left;
	winheight = imagewin->portRect.bottom - imagewin->portRect.top;
	if (withterrain && constterrain) {
		/* (should check that this is a tile?) */
		draw_as_terrain_image(0, toplineh, winwidth, winheight, constterrain);
	}
	/* Compute how many columns we can fit, rounding down but always at least 1. */
	cols = winwidth / eltw;
	if (cols <= 0) cols = 1;
	/* We can get a little wider spacing by recalculating the element width. */
	eltw = winwidth / cols;
	rows = numimages / cols;
	numvisrows = (winheight - toplineh - 15) / elth;
	if (numvisrows > rows) numvisrows = rows;
	for (col = 0; col < cols; ++col) {
		for (row = firstvisrow; row < (firstvisrow + numvisrows); ++row) {
			n = col * rows + row;
			if (n >= numimages) break;
			draw_one_image(images[n], col, row);
		}
	}
	invert_selected_imf();
	set_scrollbar();
	DrawControls(imagewin);
	DrawGrowIcon(imagewin);
	SetPort(oldport);
	EndUpdate(imagewin);
}

draw_topline()
{
	Rect tmprect;
	GrafPtr oldport;

	GetPort(&oldport);
	SetPort(imagewin);
	tmprect = imagewin->portRect;
	tmprect.bottom = tmprect.top + toplineh;
	EraseRect(&tmprect);
	/* Set up and draw an explanatory top line. */
	TextFont(monaco);
	TextSize(9);
	MoveTo(4, 12);
	sprintf(spbuf, "%d images, %d colors", numimages, numcolors);
	if (selectedimf != NULL) {
		sprintf(spbuf+strlen(spbuf), " [%s]", selectedimf->name);
	}
	if (withterrain && constterrain != NULL) {
		sprintf(spbuf+strlen(spbuf), " (shown on %s terrain)", constterrain->name);
	}
	if (withemblem && constemblem != NULL) {
		sprintf(spbuf+strlen(spbuf), " (with %s emblem)", constemblem->name);
	}
	pascalify(spbuf, tmpbuf);
	DrawString(tmpbuf);
	MoveTo(0, toplineh);
	Line(5000, 0);
	SetPort(oldport);
}

draw_one_image(imf, col, row)
ImageFamily *imf;
int col, row;
{
	int namex, namey;
	Rect tmprect, maskrect;
	FontInfo fontinfo;

	tmprect.left = col * eltw;  tmprect.top = toplineh + (row - firstvisrow) * elth;
	tmprect.right = tmprect.left + iw + 4;  tmprect.bottom = tmprect.top + ih + 4;
	InsetRect(&tmprect, 2, 2);
	/* Maybe draw the background terrain. (preferably in a hex shape) */
	if (varyterrain) {
		draw_as_terrain_image(tmprect.left, tmprect.top, iw, ih, imf);
	} else if (withterrain && constterrain) {
		draw_as_terrain_image(tmprect.left-2, tmprect.top-2, iw+4, elth, constterrain);
	}
	if (varyunit) {
		draw_as_unit_image(imagewin, tmprect.left, tmprect.top, iw, ih, imf);
	} else if (withunit && constunit) {
		draw_as_unit_image(imagewin, tmprect.left, tmprect.top, iw, ih, constunit);
	}
	/* Maybe draw an emblem. */
	if (varyemblem) {
		draw_as_emblem_image(imagewin, tmprect.left + iw - 8, tmprect.top, 8, 8, imf);
	} else if (withemblem && constemblem) {
		draw_as_emblem_image(imagewin, tmprect.left + iw - 8, tmprect.top, 8, 8, constemblem);
	}
	/* Maybe draw the name of the image. */
	if (viewnames) {
		/* If nonwhite background, add a bg for the name. */
		namex = col * eltw + iw + 4;
		namey = toplineh + (row - firstvisrow) * elth + (elth / 2) + 5;
		if (withterrain && constterrain) {
			GetFontInfo(&fontinfo);
			maskrect.left = namex;
			maskrect.top = namey - fontinfo.ascent;
			maskrect.right = maskrect.left + TextWidth(imf->name, 0, strlen(imf->name));
			maskrect.bottom = namey + fontinfo.descent + 1;
			FillRect(&maskrect, white);
		}
		MoveTo(namex, namey);
		pascalify(imf->name, tmpbuf);
		DrawString(tmpbuf);
	}
}

/* Adjust the scrollbar to reflect the size at which the images are being rendered. */

set_scrollbar()
{
	SetCtlMax(vscrollbar, rows - numvisrows);
	HiliteControl(vscrollbar, (numvisrows < rows ? 0 : 255));
}

/* Indicate which image is currently selected. */

invert_selected_imf()
{
	int row, col;
	Rect tmprect;

	if (selectedimf != NULL) {
		col = selectedn / rows;
		row = selectedn % rows;
		tmprect.left = col * eltw;  tmprect.top = toplineh + (row - firstvisrow) * elth;
		tmprect.right = tmprect.left + eltw;  tmprect.bottom = tmprect.top + elth;
		InvertRect(&tmprect);
		InsetRect(&tmprect, 1, 1);
		InvertRect(&tmprect);
	}
}

/* (should add other ways to draw) */

draw_as_terrain_image(sx, sy, sw, sh, imf)
int sx, sy, sw, sh;
ImageFamily *imf;
{
	Rect rect;
	Image *timg;

	timg = best_image(imf, sw, sh);
	rect.left = sx;  rect.top = sy;
	rect.right = sx + sw;  rect.bottom = sy + sh;
	if (timg) {
		if (usecolor && showcolor && timg->colrpat != nil) {
			FillCRect(&rect, timg->colrpat);
		} else if (timg->patdefined) {
			FillRect(&rect, (Pattern *) &(timg->pat));
		} else {
			/* If no imagery, just leave blank, don't try to make a default image. */
		}
	}
}

/* This is similar (but not identical! beware!) to Xconq's main unit drawing routine,
   but it uses an arbitrary image family instead. */

draw_as_unit_image(win, sx, sy, sw, sh, imf)
WindowPtr win;
int sx, sy, sw, sh;
ImageFamily *imf;
{
	Rect srcrect, imagerect;
	RgnHandle tmprgn;
	BitMap bm, *winbits;
	Image *uimg;

	imagerect = win->portRect;
	uimg = best_image(imf, sw, sh);
	/* There should always be *some* image to display. */
	if (uimg) {
		imagerect.top += sy;  imagerect.left += sx;
		imagerect.bottom = imagerect.top + sh;  imagerect.right = imagerect.left + sw;
		winbits = &(((GrafPtr) win)->portBits);
		if (uimg->monopict != nil) {
			DrawPicture(uimg->monopict, &imagerect);
		} else if (usecolor && showcolor && uimg->colricon != nil) {
			PlotCIcon(&imagerect, uimg->colricon);
		} else if (uimg->monoicon != nil) {
			SetRect(&srcrect, 0, 0, 32, 32);
			bm.rowBytes = 4;
			bm.bounds = srcrect;
			if (uimg->maskicon != nil) {
				bm.baseAddr = *(uimg->maskicon);
				CopyBits(&bm, winbits, &srcrect, &imagerect, srcBic, nil);
			} else {
				/* Draw unit bbox as default mask. (maybe shrink a little??) */
				FillRect(&imagerect, white);
			}
			bm.baseAddr = *(uimg->monoicon);
			CopyBits(&bm, winbits, &srcrect, &imagerect, srcOr, nil);
		} else if (uimg->monosicn != nil) {
			SetRect(&srcrect, 0, 0, 16, 16);
			bm.rowBytes = 2;
			bm.bounds = srcrect;
			if (uimg->masksicn != nil) {
				bm.baseAddr = *(uimg->masksicn);
				CopyBits(&bm, winbits, &srcrect, &imagerect, srcBic, nil);
			} else {
				/* Draw unit bbox as default mask. (maybe shrink a little??) */
				FillRect(&imagerect, white);
			}
			bm.baseAddr = *(uimg->monosicn);
			CopyBits(&bm, winbits, &srcrect, &imagerect, srcOr, nil);
		} else if ((usecolor && showcolor && uimg->colrpat) || uimg->patdefined) {
			draw_as_terrain_image(sx, sy, sw, sh, imf);
		} else {
			/* should never be possible? */
		}
	}
}

/* Draw a given side's emblem. Uses the current GrafPort. */

draw_as_emblem_image(win, ex, ey, ew, eh, imf)
WindowPtr win;
int ex, ey, ew, eh;
ImageFamily *imf;
{
	Rect srcrect, imagerect = win->portRect;
	RgnHandle tmprgn;
	BitMap bm, *winbits;
	Image *eimg;

	eimg = best_image(imf, ew, eh);
	imagerect.top += ey;  imagerect.left += ex;
	imagerect.bottom = imagerect.top + eh;  imagerect.right = imagerect.left + ew;
	/* If an image is present, display it, otherwise just suppress. */
	if (eimg) {
		winbits = &(((GrafPtr) win)->portBits);
		if (eimg->monopict != nil) {
			DrawPicture(eimg->monopict, &imagerect);
		} else if (usecolor && showcolor && eimg->colricon != nil) {
			PlotCIcon(&imagerect, eimg->colricon);
		} else if (eimg->monoicon != nil) {
			SetRect(&srcrect, 0, 0, 32, 32);
			bm.rowBytes = 4;
			bm.bounds = srcrect;
			if (eimg->maskicon != nil) {
				bm.baseAddr = *(eimg->maskicon);
				CopyBits(&bm, winbits, &srcrect, &imagerect, srcBic, nil);
			} else {
				/* Draw unit bbox as default mask. (maybe shrink a little??) */
				FillRect(&imagerect, white);
			}
			bm.baseAddr = *(eimg->monoicon);
			CopyBits(&bm, winbits, &srcrect, &imagerect, srcOr, nil);
		} else if (eimg->monosicn != nil) {
			SetRect(&srcrect, 0, 0, 16, 16);
			bm.rowBytes = 2;
			bm.bounds = srcrect;
			if (eimg->masksicn != nil) {
				bm.baseAddr = *(eimg->masksicn);
				CopyBits(&bm, winbits, &srcrect, &imagerect, srcBic, nil);
			} else {
				/* Draw unit bbox as default mask. (maybe shrink a little??) */
				FillRect(&imagerect, white);
			}
			bm.baseAddr = *(eimg->monosicn);
			CopyBits(&bm, winbits, &srcrect, &imagerect, srcOr, nil);
		} else {
			/* should never be possible? */
		}
	}
}

/* Try to find the best of multiple images for the given bounding box. */
/* Don't return anything that won't fit in min space. */

Image *
best_image(imf, w, h)
ImageFamily *imf;
int w, h;
{
	int i;
	Image *img, *fallback = NULL;
	
	for (i = 0; i < imf->numsizes; ++i) {
		img = &(imf->images[i]);
		if (w >= img->minw && h >= img->minh) {
			if (!fallback || (img->w > fallback->w && img->h > fallback->h)) {
				fallback = img;
			}
		}
		if (w <= img->maxw && h <= img->maxh
			&& ((selecttiles && img->istile) || (selecticons && !img->istile))) {
			return img;
		}
	}
	return (((selecttiles && fallback->istile)
			|| (selecticons && !fallback->istile)) ? fallback : NULL);
}

/* Lisp reader support. */

/* There will be no Xconq types to interpret. */

int numutypes = 0;
int nummtypes = 0;
int numttypes = 0;

FILE *errorfp = NULL;

announce_read_progress() {}

char *
copy_string(str)
char *str;
{
    int len = strlen(str);
    char *rslt;

    rslt = (char *) xmalloc(len + 1);
    strcpy(rslt, str);
    return rslt;
}

int
xmalloc(amt)
unsigned amt;
{
    int value = (int) malloc (amt);

    if (value == 0) {
	/* This is pretty serious, just have to get out quickly. */
	run_error("Memory exhausted!!");
	exit(1);  /* case run_error doesn't do it */
    }
    return value;
}

init_warning(str, a1, a2, a3)
char *str;
long a1, a2, a3;
{
	/* Cursor may be weird from loading, reset it. */
	SetCursor(&qd.arrow);
	sprintf(spbuf, str, a1, a2, a3);
	pascalify(spbuf, tmpbuf);
	ParamText(tmpbuf, "\p", "\p", "\p");
	switch (CautionAlert(128, nil)) {
		case 1:
			/* Just keep going, hope that warning was a false alarm. */
			/* (if option key on, should suppress future warnings) */
			break;
	}
}

/* An init error is not necessarily fatal, but have to start over. */

init_error(str, a1, a2, a3)
char *str;
long a1, a2, a3;
{
	/* Cursor may be weird from loading, reset it. */
	SetCursor(&qd.arrow);
	sprintf(spbuf, str, a1, a2, a3);
	pascalify(spbuf, tmpbuf);
	ParamText(tmpbuf, "\p", "\p", "\p");
	switch (StopAlert(128, nil)) {
		case 1:
			/* Just keep going, hope that warning was a false alarm. */
			/* (if option key on, should suppress future warnings) */
			break;
	}
}

/* An run error is fatal, but allow an emergency save, might be able to salvage. */

run_error(str, a1, a2, a3)
char *str;
long a1, a2, a3;
{
	sprintf(spbuf, str, a1, a2, a3);
	pascalify(spbuf, tmpbuf);
	ParamText(tmpbuf, "\p", "\p", "\p");
	/* (add the save button and handler code here) */
	switch (StopAlert(128, nil)) {
		case 1:
			break;
		case 2:
			break;
		case 3:
			break;
	}
	ExitToShell();
}

/* Runtime warnings are for when it's important to bug the players,
   but doesn't necessarily mean imminent danger of a crash. */

run_warning(str, a1, a2, a3)
char *str;
long a1, a2, a3;
{
	/* Cursor may be weird from loading, reset it. */
	SetCursor(&qd.arrow);
	sprintf(spbuf, str, a1, a2, a3);
	pascalify(spbuf, tmpbuf);
	ParamText(tmpbuf, "\p", "\p", "\p");
	switch (CautionAlert(128, nil)) {
		case 1:
			/* Just keep going, hope that warning was a false alarm. */
			/* (if option key on, should suppress future warnings) */
			break;
	}
}

