/* $XConsortium: Imlist.h,v 1.5 90/12/19 18:46:00 converse Exp $ */

/* Copyright	Massachusetts Institute of Technology	1987, 1988
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of M.I.T. not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  M.I.T. makes no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * M.I.T. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL M.I.T.
 * BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

#ifndef _Imlist_h
#define _Imlist_h

/****************************************************************
 *
 * Imlist widget
 *
 ****************************************************************/

/* Resources:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		Pixel		XtDefaultBackground
 border		     BorderColor	Pixel		XtDefaultForeground
 borderWidth	     BorderWidth	Dimension	1
 destroyCallback     Callback		Pointer		NULL
 height		     Height		Dimension	0
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 sensitive	     Sensitive		Boolean		True
 width		     Width		Dimension	0
 x		     Position		Position	0
 y		     Position		Position	0

 images		     Position		Position	0
 imageNames
 pattern/icon
 minBox
 maxBox
 imageBg
 imageFg
 minDepth
 maxDepth
 hex/square tiling

The theory of this widget is that it provides a list of icons displayed
at multiple bit depths and sizes, possibly with a textual legend.

If the min/max pairs match each other, then only one icon will be shown.

In general, this is similar to the List widget.

*/

/* define any special resource names here that are not in <X11/StringDefs.h> */

#if 0
#define XtN ""
#define XtC ""
#endif

typedef struct _XawImlistCallData {
  XEvent *event;		/* the event causing the ImlistAction */
  String *params;		/* the TranslationTable params */
  Cardinal num_params;		/* count of params */
} XawImlistCallDataRec, *XawImlistCallData,
    ImlistCallDataRec, *ImlistCallData; /* supported for R4 compatibility */

/* declare specific ImlistWidget class and instance datatypes */

typedef struct _ImlistClassRec*	ImlistWidgetClass;
typedef struct _ImlistRec*		ImlistWidget;

/* declare the class constant */

extern WidgetClass imlistWidgetClass;

#endif /* _Imlist_h */
