/* Copyright (c) 1987, 1988, 1991, 1992  Stanley T. Shebs. */
/* This program may be used, copied, modified, and redistributed freely */
/* for noncommercial purposes, so long as this notice remains intact. */

/* This file contains almost all command functions. */

#include "conq.h"
#include "mplay.h"
#include "xtconq.h"

char *grok_string();

Unit *
current_unit(side)
Side *side;
{
    return NULL;
}

Unit *
selected_unit(side)
Side *side;
{
    return NULL;
}


/* Tests if state-altering commands are allowed at all. */

may_interfere(side)
Side *side;
{
    return (1 /* humanside(side) */);
}

do_find_next_mover(side, n)
Side *side;
int n;
{
#if 0
    Unit *thisunit, *unit;

    if (side->curactor) {
	thisunit = side->curactor;
    } else {
	thisunit = side->actorder;
    }
    
    if (thisunit == NULL) cmd_error(side, "no units?");
	
    unit = thisunit->nextactor;
    while (unit != NULL) {
	if (alive(unit) && 1 /* unit->actionsleft > 0 */) {
	    side->curactor = unit;
	    make_current(side, unit);
	    return;
	}
	unit = unit->nextactor;
    }
    /* Start over from the beginning. */
    unit = side->actorder;
    while (unit != thisunit) {
	if (alive(unit) && 1 /* unit->actionsleft > 0 */) {
	    side->curactor = unit;
	    make_current(side, unit);
	    return;
	}
	unit = unit->nextactor;
    }
    cmd_error(side, "couldn't find any besides %s to move!",
	      unit_handle(side, unit));
#endif
}

do_find_prev_mover(side, n)
Side *side;
int n;
{
#if 0
    Unit *unit;

    unit = (current_unit(side) ? current_unit(side)
	    : side->unithead->prev);

    for ( ; unit != side->unithead; unit = unit->prev) { 
	if (alive(unit) && unit->side == side && unit->actionsleft > 0) {
	    if (unit == current_unit(side)) {
		notify(side, "That's it!");
	    } else {
		make_current(side, unit);
	    }
	    return;
	}
    }
    cmd_error(side, "No units to move!");
#endif
}

#if 0
/* Move in given direction a given distance - used for both single and */
/* automatic multiple moves. */

do_dir(side, dir, n)
Side *side;
int dir, n;
{
    if (side->ui->reqmap != NULL
	&& side->ui->reqmap->curunit != NULL)
      order_movedir(side->ui->reqmap->curunit, dir, n);
}
#endif

/* Wake *everything* (that's ours) within the given radius.  Two commands */
/* actually; lowercase is transports only, uppercase is everybody. */

do_wakeup(side, n)
Side *side;
int n;
{
#if 0
    if (side->ui->teach) {
	cache_awake(side);
    } else {
	wakeup_area(side, n, TRUE);
    }
#endif
}

/* Wake up only the main/current unit in a hex. */

do_wakemain(side, n)
Side *side;
int n;
{
#if 0
    if (side->ui->teach) {
	cache_awake(side);
    } else {
/*        if (current_unit(side) != NULL)
	  wake_unit(current_unit(side), FALSE, WAKEFULL, (Unit *) NULL);  */
	wakeup_area(side, n, FALSE);
    }
#endif
}

/* The area wakeup. */

int tmpflag;

wake_at(x, y)
int x, y;
{
    Unit *unit = unit_at(x, y);

/*    if (unit != NULL && (unit->side == tmpside || tmpside->designer))
	wake_unit(unit, tmpflag, WAKEFULL, (Unit *) NULL);  */
}

wakeup_area(side, n, occs)
Side *side;
int n, occs;
{
#if 0
    tmpside = side;
    tmpflag = occs;
/*    apply_to_area(side->ui->front->curx, side->ui->front->cury, n, wake_at); */
#endif
}

/* Put unit to sleep for a while.  If we sleep it next to something that */
/* might wake it up, then adjust flags so it won't wake up on next turn. */

do_sentry(side, unit, n)
Side *side;
Unit *unit;
int n;
{
#if 0
    if (side->ui->teach) {
	cache_sentry(side, n);
    } else {
	order_sentry(unit, n);
	if (n > 1 && adj_enemy(unit))
	    unit->plan->orders.flags &= ~(ENEMYWAKE|NEUTRALWAKE);
    }
#endif
}

do_sit(side, n)
Side *side;
int n;
{
#if 0
    if (current_unit(side) != NULL) {
	do_sentry(side, current_unit(side), 1);
    } else {
	cmd_error(side, "No unit to operate on here!");
    }
#endif
}

/* Set unit to move to a given location.  */

x_moveto(side)
Side *side;
{
#if 0
    if (grok_position(side)) {
	if (side->ui->teach) {
	    cache_moveto(side, side->ui->reqposx, side->ui->reqposy);
	} else if (side->designer) {
	    leave_hex(side->ui->requnit);
	    enter_hex(side->ui->requnit, side->ui->reqposx, side->ui->reqposy);
/*
	    make_current(side, side->ui->requnit);
	    all_see_hex(side->ui->front->curx, side->ui->front->cury);
*/
	} else {
	    order_moveto(side->ui->requnit, side->ui->reqposx, side->ui->reqposy);
	}
	restore_cur(side);
    } else {
	request_input(side, x_moveto);
    }
#endif
}

/* The command proper. */

do_moveto(side, unit, n)
Side *side;
Unit *unit;
int n;
{
#if 0
    if (!may_interfere(side)) {
	cmd_error(side, "Hands off!");
    } else {
	ask_position(side, "Move to where?");
	side->ui->requnit = unit;
	request_input(side, x_moveto);
    }
#endif
}

/* Determine how far away another point is.  */

x_distance(side)
Side *side;
{

    if (grok_position(side)) {
      restore_cur(side);
      notify(side, "?");
    } else {
	request_input(side, x_distance);
    }
}

/* The command proper. */

do_distance(side, n)
Side *side;
int n;
{
    ask_position(side, "Distance to where?");
    request_input(side, x_distance);
/*    side->ui->reqposx = side->ui->front->curx;  side->ui->reqposy = side->ui->front->cury;  */
}

/* Auxiliary stuff used when searching for place to return to.  Note that */
/* a good refueling spot will be woken up, so it won't get too far away */
/* before unit has a chance to get there. */
/* Won't find refueling places inside other units, sigh. */

refuel_here(x, y)
int x, y;
{
    Unit *unit;

    for_all_stack(x, y, unit) {
	/* what about allies? */
	if (unit->side == tmpside && can_carry(unit, tmpunit)) {
	    /* this should be controlled by doctrine? */
	    /* shouldn't wake up, should get a new task to "wait up"
	       or even approach if possible */
/*	    wake_unit(unit, FALSE, WAKEOWNER, NULL);  */
	    return TRUE;
	}
	/* should look at occupants too */
    }
    return FALSE;
}

/* Search for a friendly refueler within range and set course for it.  */
/* Warn player and refuse to move if nothing close enough. */

/* (Should change to be appropriate for all unit types.) */
/* search should account for different possible paths... */

do_return(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    int x, y, u = unit->type, r, range = area.maxdim;

    for_all_material_types(r) {
	if (um_tomove(u, r) > 0) {
	    range = min(range, unit->supply[r] / um_tomove(u, r));
	}
    }
    tmpside = side;
    tmpunit = unit;
    if (refuel_here(unit->x, unit->y)) {
	cmd_error(side, "Already at a resupply point!");
    } else if (search_area(unit->x, unit->y, range, refuel_here, &x, &y, 1)) {
	/* needs to be a task */
	/* should tweak plan so that most efficient route chosen */
	order_moveto(unit, x, y);
    } else {
	cmd_error(side, "No resupply point in range!");
    }
}

/* The command proper just sets up the interaction. */

do_coast(side, unit, n)
Side *side;
Unit *unit;
int n;
{
}

/* Set orders to follow a leader unit. */

x_follow(side)
Side *side;
{
#if 0
    Unit *leader;

    if (grok_position(side)) {
	if ((leader = unit_at(side->ui->reqposx, side->ui->reqposy)) != NULL &&
	    leader->side == side) {
	    if (leader != side->ui->requnit) {
		if (side->ui->teach) {
		    cache_follow(side, leader, side->ui->reqvalue2);
		} else {
		    order_follow(side->ui->requnit, leader, side->ui->reqvalue2);
		}
	    } else {
		cmd_error(side, "Unit can't follow itself!");
	    }
	} else {
	    cmd_error(side, "No unit to follow!");
	}
	restore_cur(side);
    } else {
	request_input(side, x_follow);
    }
#endif
}

/* The command proper. */

do_follow(side, unit, n)
Side *side;
Unit *unit;
int n;
{
#if 0
    ask_position(side, "Which unit to follow?");
    side->ui->requnit = unit;
    request_input(side, x_follow); 
/*    side->ui->reqposx = side->ui->front->curx;  side->ui->reqposy = side->ui->front->cury;  */
    side->ui->reqvalue2 = n;
#endif
}

/* Patrolling goes back and forth between two points.  First point is the */
/* current position. */

x_patrol(side)
Side *side;
{
#if 0
    if (grok_position(side)) {
	if (side->ui->teach) {
	    cache_patrol(side, side->ui->sounit->x, side->ui->sounit->y,
			 side->ui->reqposx, side->ui->reqposy, side->ui->reqvalue2);
	} else {
	    order_patrol(side->ui->requnit, side->ui->requnit->x, side->ui->requnit->y,
			 side->ui->reqposx, side->ui->reqposy, side->ui->reqvalue2);
	}
	restore_cur(side);
    } else {
	request_input(side, x_patrol);
    }
#endif
}

/* The command proper. */

do_patrol(side, unit, n)
Side *side;
Unit *unit;
int n;
{
#if 0
    ask_position(side, "What other endpoint for patrol?");
    side->ui->requnit = unit;
    request_input(side, x_patrol);
/*    side->ui->reqposx = side->ui->front->curx;  side->ui->reqposy = side->ui->front->cury;  */
    side->ui->reqvalue2 = n;
#endif
}

/* Delay a unit's move until a later time.  The set flag will be recognized */
/* by the movement loops, when deciding which unit to move next. */

do_delay(side, unit, n)
Side *side;
Unit *unit;
int n;
{
#if 0
  if (side->mode == MOVE) {
    side->movunit = NULL;
    notify(side, "Delaying moving %s.", unit_handle(side, unit));
  }
#endif
}

/* Give a unit to another side (possibly to neutrals).  Units that won't */
/* change their sides when captured won't change voluntarily either. */

/* (but giving to neutral should be tested, otherwise might kill unit) */

do_give_unit(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    int u = unit->type;

    if (/* u_change_side(u) || */ side->designer) {
	unit_changes_side(unit, side_n(n), CAPTURE, PRISONER);
	all_see_hex(unit->x, unit->y);
#if 0
	if (period_setproduct()) {
	  set_product(unit, NOTHING);
	  unit->schedule = 0;
	} 
#endif
   } else {
	cmd_error(side, "You can't just give away the %s!", u_type_name(u));
    }
}

/* Marking is for the purpose of rearranging units within a hex. */

do_mark_unit(side, unit, n)
Side *side;
Unit *unit;
int n;
{
/*    side->markunit = unit;  */
    notify(side, "%s has been marked.", unit_handle(side, unit));
}

/* This is a clever (if I do say so myself) command to examine all occupants */
/* and suboccupants, in an inorder fashion. */

/* Should have an option to open up a list window that shows everything
   all at once. */

do_occupant(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    Unit *nextup;

    if (unit->occupant != NULL) {
	make_current(side, unit->occupant);
    } else if (unit->nexthere != NULL) {
	make_current(side, unit->nexthere);
    } else {
	nextup = unit->transport;
	if (nextup != NULL) {
	    while (nextup->transport != NULL && nextup->nexthere == NULL) {
		nextup = nextup->transport;
	    }
	    if (nextup->nexthere != NULL)
	      make_current(side, nextup->nexthere);
	    if (nextup->transport == NULL)
	      make_current(side, nextup);
	} else {
	    /* This is a no-op if there is no stacking within a hex. */
	    make_current(side, unit_at(unit->x, unit->y));
	}
    }
}

/* This can actually do general rearrangement, but defaults to putting the */
/* unit on the first available transport in the hex.  */
/* What about trying to embark a unit on itself or on its previous transp? */

do_embark(side, unit, n)
Side *side;
Unit *unit;
int n;
{
#if 0
    Unit *mainunit = unit_at(unit->x, unit->y);
    Unit *transport;

    if (side->ui->teach) {
	cache_embark(side, n);
    } else {
	if (mainunit != unit) {
#if 0
	    if (side->markunit == NULL ||
		side->markunit->x != unit->x || side->markunit->y != unit->y) {
		for_all_occupants(mainunit, transport) {
		    if (can_carry(transport, unit)) break;
		}
	    } else {
		transport = side->markunit;
	    }
#endif
	    if (transport != NULL) {
		/* needs some work... */
		transfer_unit_action(unit, unit, transport);
#if 0
		if (can_carry(transport, unit)) {
		    leave_hex(unit);
		    enter_transport(unit, transport);
		    if (n > 0) order_sentry(unit, n);
		    return TRUE;
		}
		else {
		    if (n > 0) order_embark(unit, n);
		    else cmd_error(side, "Marked unit already full.");
		}
#endif
	    } else {
		if (n > 0) order_embark(unit, n);
		else cmd_error(side, "No plausible transport!");
	    }
	} else {
	    cmd_error(side, "Nothing for this unit to get into!");
	}
	return FALSE;
    }
#endif
}

/* Give supplies to a transport.  The argument tells how many to give. */

do_give(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    int something = FALSE;
    int u = unit->type, m, r, gift, actual;
    Unit *main = unit->transport;

    if (main != NULL) {
	sprintf(spbuf, "");
	m = main->type;
	for_all_material_types(r) {
	    gift = (n < 0 ? (um_storage(m, r) - main->supply[r]) : n);
	    if (gift > 0) {
		something = TRUE;
		/* Be stingy if we're low */
		if (2 * unit->supply[r] < um_storage(u, r))
		    gift = max(1, gift/2);
		actual = transfer_supply(unit, main, r, gift);
		sprintf(tmpbuf, " %d %s", actual, m_type_name(r));
		strcat(spbuf, tmpbuf);
	    }
	}
	if (something) {
	    notify(side, "%s gave%s.", unit_handle(side, unit), spbuf);
	} else {
	    notify(side, "%s gave nothing.", unit_handle(side, unit));
	}
    } else {
	cmd_error(side, "Can't transfer supplies here!");
    }
}

/* Take supplies from transport.  Both the transport must have something */
/* left. */

do_take(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    int something = FALSE;
    int u = unit->type, m, r, need, actual;
    Unit *main = unit->transport;

    if (main != NULL) {
	sprintf(spbuf, "");
	m = main->type;
	for_all_material_types(r) {
	    need = (n < 0 ? um_storage(u, r) - unit->supply[r] : n);
	    if (need > 0) {
		something = TRUE;
		/* Be stingy if we're low */
		if (2 * main->supply[r] < um_storage(m, r))
		    need = max(1, need/2);
		actual = transfer_supply(main, unit, r, need);
		sprintf(tmpbuf, " %d %s", actual, m_type_name(r));
		strcat(spbuf, tmpbuf);
	    }
	}
	if (something) {
	    notify(side, "%s got%s.", unit_handle(side, unit), spbuf);
	} else {
	    notify(side, "%s needed nothing.", unit_handle(side, unit));
	}
    } else {
	cmd_error(side, "Can't transfer supplies here!");
    }
}

/* Take the current player out of the game while letting everybody else */
/* continue on. */

ask_side()
{
}

Side *
grok_side()
{
    return NULL;
}

x_resign_2(side)
Side *side;
{
    Side *side2 = grok_side(side);

    /* should be able to cancel from here */

    resign_game(side, side2);
}

/* Resigning *to* somebody might make sense in a two-player game with
   certain VCs. */

x_resign(side)
Side *side;
{
    if (grok_bool(side)) {
	if (numsides > 2) {
	    ask_side(side, "Who do you want to surrender to?", NULL);
	    request_input(side, x_resign_2);
	} else {
	    resign_game(side, NULL);
	}
    }
}

/* The resignation command proper. */

do_resign(side, n)
Side *side;
int n;
{
    if (side->lost) {
	/* Assume that a losing side just wants out, no need to confirm. */
	if (active_display(side)) {
	    /* Is this sufficient to remove a player entirely? */
	    close_display(side);
	}
    } else {
	ask_bool(side, "Do you really want to give up?", FALSE);
	request_input(side, x_resign);
    }
}

/* Leave quickly when the boss walks by.  One person can kill a multi-player
   game, which isn't too great, but the alternatives are complicated.
   The stats file will be left behind, to foment argument about who would
   have won...

   This routine also includes a trapdoor for freezing/unfreezing
   machine players when designing. */

/* (Have an extra confirm for designers not to lose unsaved work??) */

x_exit(side)
Side *side;
{
    Unit *unit;

    if (1 /* grok_bool(side) */) {
	exit_xconq(side);
    }
}

/* This routine should be called before any sort of non-death exit. */

exit_xconq(side)
Side *side;
{
    printf("\n%s\n\n", exit_commentary(side));
    /* (should this really happen first?) */
    close_displays();
    /* need to make the commentary */
    exit(0);
}

/* The exit command sets up a confirmation. */

do_exit(side, n)
Side *side;
int n;
{
    if (side->lost) {
	if (0 /* numhumans > 1 */) {  /* should be "num active displays" */
	    /* At this point, killing the game is the same as resigning. */
	    do_resign(side, n);
	} else {
	    x_exit(side);
	}
    } else {
	ask_bool(side, "Do you REALLY want to end the game for EVERYBODY?",
		 FALSE);
	request_input(side, x_exit);
    }
}

/* Stuff game state into a file.  By default, it goes into the current
   directory.  If building a scenario, we can specify just which parts
   of the game state are to be written. */

#ifdef DESIGNERS

save_a_module(side)
Side *side;
{
    char *rawcontents = "everything";
    Module *module;
    Obj *contents;

    /* need to be able to get this name from somewhere */
    module = create_game_module("random.scn");
    /* need something better to turn contents into a Lisp object */
    contents = intern_symbol(rawcontents);
    interpret_content_spec(module, contents);
    notify(side, "File will be written to \"%s\" ...", module->filename);
    if (write_game_module(module, contents)) {
	notify(side, "Done writing to \"%s\".", module->filename);
    } else {
	cmd_error(side, "Can't open file \"%s\"!", module->filename);
    }
}

#endif /* DESIGNERS */

/* Make a module appropriate to a save file, write the file, and leave. */

save_the_game(side)
Side *side;
{
    notify_all("Game will be saved to \"%s\" ...", savefile_name());
    if (write_entire_game_state(savefile_name())) {
#ifdef EXIT_ON_SAVE
	close_displays();
	/* this should be conditional? */
	exit(0);
#endif
    } else {
	cmd_error(side, "Can't open file \"%s\"!", savefile_name());
    }
}

/* Redraw everything using the same code as when windows need a redraw. */

#if 0 /* def PREVVIEW */ /* this goes on a control button */
do_redraw(side, n)
Side *side;
int n;
{
    if (n > 0) {  /* remove the views of units likely to have moved. */
	int x, y, ts;

      for_all_hexes(x, y)
	  if (side_view_age(side, x, y) > n) {
	    int viewunit = vtype(side_view(side, x, y));

	    if (viewunit != EMPTY && viewunit != UNSEEN
		&& mobile(viewunit)) { 
	      ts = side_view_timestamp(side, x, y);
	      set_side_view(side, x, y, EMPTY);
	      side_view_timestamp(side, x, y) = ts;
	    }
	  }
    }
    recalc_caches();
    redraw(side);
}
#endif

recalc_caches()
{
#if 0
    int u;
    Unit *unit;
    Side *side;

    for_all_sides(side) {
	for_all_unit_types(u) {
	    side->units[u] = 0;
	    side->unitsbuilding[u] = 0;
	}
	for_all_side_units(side, unit) {
	    if (alive(unit)) {
		if (completed(unit)) {
		    ++(side->units[unit->type]);
		} else {
		    ++(side->unitsbuilding[unit->type]);
		}
	    }
	}
    }
#endif
}

/* Name or rename the current unit or a given side.  We make a copy of the */
/* string after it's been successfully read, just in case. */

x_name(side)
Side *side;
{
#if 0
    char *name;
    Side *side2;

    if ((name = grok_string(side)) == NULL) {
	request_input(side, x_name);
    } else if (strlen(name) == 0) {
	notify(side, "Name not changed.");
    } else if (side->ui->requnit != NULL) {
	side->ui->requnit->name = copy_string(name);
    } else if (side->ui->reqoside != NULL) {
	side->ui->reqoside->name = copy_string(name);
	for_all_sides(side2) show_game_state(side2);
    } else {
	cmd_error(side, "Nothing to name!");
    }
#endif
}

/* The command proper decides between unit and side naming. */

do_name(side, n)
Side *side;
int n;
{
#if 0
    if (current_unit(side) != NULL) {
	ask_string(side, "New name for unit:", current_unit(side)->name);
    } else {
	ask_string(side, "New name for yourself:", side->name);
	side->ui->reqoside = side;
    }
    side->ui->requnit = current_unit(side);
    request_input(side, x_name);
#endif
}

/* Stop the clock. */

/* (Needs some restrictions to prevent abuse.) */

do_pause(side, n)
Side *side;
int n;
{
    extern int paused;
    Side *side2;

    paused = !paused;
    for_all_sides(side2) {
/*	show_game_state(side2);  */
    }
}

/* Do some construction of new units. */

do_build(side)
Side *side;
{
#if 0
    Unit *unit = NULL;

    if (0 /* !period_setproduct() */) {
	cmd_error(side, "No construction changes allowed in this game!");
    } else if (!may_interfere(side)) {
	cmd_error(side, "Hands off!");
    } else {
	/* Pick a unit. */
	unit = side->ui->closeups->unit;

	if (unit == NULL) {
	    cmd_error(side, "No unit to build with!");
	} else if (unit->side != side && !side->designer) {
	    cmd_error(side, "Not one of your units!");
	} else if (0 /* !can_build(unit) */) {
	    cmd_error(side, "This unit can't build anything!");
	} else if (!u_occproduce(unit->type) && unit->transport != NULL){
	    cmd_error(side, "This unit can't build anything while inside another unit!");
	} else {
	    /* should include side too, might not be same as unit side */
	    /* also need to disable any automated activity */
	    unit->plan->tasks = NULL;  /* hack */
	    unit->plan->awaitingorders = FALSE;
	    request_new_product(unit);
	}
    }
#endif
}

/* Setting what a unit will produce next. */

do_next_product(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    if (0 /* !period_setproduct() */) {
	cmd_error(side, "No construction changes allowed!");
    } else if (!may_interfere(side)) {
	cmd_error(side, "Hands off!");
    } else {
	if (0 /* !can_build(unit) */) {
	    cmd_error(side, "This unit can't build anything!");
/*      } else if (!u_occproduce(unit->type) && unit->transport != NULL){
	cmd_error(side, "This unit can't build anything while inside another unit!"); */
      } else {
	  /* why wakeup? */
/*	  wake_unit(unit, FALSE, WAKEOWNER, NULL);  */
	  request_next_product(unit);
      }
    }
}

/* Set a unit to not produce anything (yes, this really is useful). */

do_idle(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    if (0 /* !period_setproduct() */) {
	cmd_error(side, "No construction changes allowed!");
    } else {
/*	set_product(unit, NONUTYPE);  */
/*	unit->schedule = n;  */
/*	show_all_info(side);  update closeups? */
    }
}

/* Send a short (1 line) message to another player.  Some messages are */
/* recognized specially, causing various actions. */

x_message(side)
Side *side;
{
#if 0
    char *msg;
    Side *side3;

    if ((msg = grok_string(side)) != NULL) {
	if (side->ui->reqoside == NULL) {
	    if (msg != NULL && strlen(msg) > 0) {
		notify_all("The %s announce: %s",
			   plural_form(side->name), msg);
	    }
	} else if (strcmp(msg, "briefing") == 0) {
	    notify(side->ui->reqoside, "Receiving a briefing from the %s...",
		   plural_form(side->name));
	    reveal_side(side, side->ui->reqoside, 100);
	    notify(side, "You just briefed the %s on your position.",
		   plural_form(side->ui->reqoside->name));
	} else if (strcmp(msg, "alliance") == 0) {
	    notify(side, "You propose a formal alliance with the %s.",
		   plural_form(side->ui->reqoside->name));
	    side->relationships[side_number(side->ui->reqoside)] = ALLY;
	    if (side->ui->reqoside->relationships[side_number(side)] >= ALLY) {
		declare_alliance(side, side->ui->reqoside);
		for_all_sides(side3) redraw(side3);
	    } else {
		notify(side->ui->reqoside, "The %s propose a formal alliance.",
		       plural_form(side->name));
	    }
	} else if (strcmp(msg, "neutral") == 0) {
	    notify(side, "You propose neutrality with the %s.",
		   plural_form(side->ui->reqoside->name));
	    side->relationships[side_number(side->ui->reqoside)] = NEUTRAL;
	    if (side->ui->reqoside->relationships[side_number(side)] == NEUTRAL) {
		declare_neutrality(side, side->ui->reqoside);
		for_all_sides(side3) redraw(side3);
	    } else {
		notify(side->ui->reqoside, "The %s propose neutrality.",
		       plural_form(side->name));
	    }
	} else if (strcmp(msg, "war") == 0) {
	    notify(side, "You declare war on the %s!",
		   plural_form(side->ui->reqoside->name));
	    declare_war(side, side->ui->reqoside);
	    for_all_sides(side3) redraw(side3);
	} else if (strlen(msg) > 0) {
	    notify(side->ui->reqoside, "The %s say to you: %s",
		   plural_form(side->name), msg);
	} else {
	    notify(side, "You keep your mouth shut.");
	}
    } else {
	request_input(side, x_message);
    }
#endif
}

/* The command proper. */

do_message(side, n)
Side *side;
int n;
{
#if 0
    char prompt[BUFSIZE];
    Side *side2;

    side2 = side_n(n);
    side->ui->reqoside = side2;
    if (side != side2) {
	if (side2) {
	    sprintf(prompt, "Say to the %s: ", plural_form(side2->name));
	} else {
	    sprintf(prompt, "Broadcast: ");
	}
	ask_string(side, prompt, (char *) NULL);
	request_input(side, x_message);
    } else {
	cmd_error(side, "You mumble to yourself.");
    }
#endif
}


/* toggle followaction flag */

do_look(side, n)
Side *side;
int n;
{
#if 0
  if (n == -1)
    side->ui->followaction = !side->ui->followaction;
  else side->ui->followaction = n;
#endif
}

/* Set the unit to automatic control.  */

do_auto(side, unit, n)
Side *side;
Unit *unit;
int n;
{
#if 0
    if (side->ui->teach) {
	cache_auto(side);
    } else {
        if (current_unit(side) != NULL)
	  unit->plan->orders.morder = TRUE;
    }
#endif
}

/* Commands that designers use to build stuff. */

#ifdef DESIGNERS
/* Create a unit of given type, position, and side. */

add_unit(side, x, y, u, s)
Side *side;
int x, y, u, s;
{
    Unit *unit;

    if (!side->designer) {
	cmd_error(side, "No permission to create units!");
    } else {
	unit = create_unit(u);
	/* Will stack, not be occupant - must move after creation */
	enter_hex(unit, x, y);
	init_supply(unit);
	unit_changes_side(unit, side_n(s), -1, -1);
	all_see_hex(x, y);
    }
}
#if 0
set_map_curttype(side, map, t, n)
Side *side;
Map *map;
int t, n;
{
    map->curttype = t;
/*    show_controls(side, map);  */
}
#endif
/* Function to change just one hex and to echo that change. */
/* Don't need to make it show instantly, can wait. */

set_one_hex(x, y)
int x, y;
{
    set_terrain_at(x, y, tmpttype);
    see_exact(tmpside, x, y);
    draw_hex(tmpside, x, y, FALSE);
}

/* Basic terrain painting command. */

paint_terrain(side, x, y, w2, h2, t)
Side *side;
int x, y, t;
{
    int i;

    if (!side->designer) {
	cmd_error(side, "No permission to alter terrain!");
    } else {
	tmpside = side;
	tmpttype = t;
	apply_to_hexagon(x, y, w2, h2, set_one_hex);
    }
}

/* Make a sequence of the border type, running more or less in a line. */

paint_border_line(side, fx, fy, tx, ty, t)
Side *side;
int fx, fy, tx, ty, t;
{
#if 0
    if (!side->designer) {
	cmd_error(side, "No permission to alter borders!");
    } else if (numbdtypes <= 0) {
	cmd_error(side, "No border types to paint!");
    } else {
	if (!area.borders) allocate_area_borders();
	tmpside = side;
	tmpttype = t;
    }
#endif
}

/* Lay down a connection running between the two given points. */

paint_connection_line(side, fx, fy, tx, ty, t)
Side *side;
int fx, fy, tx, ty, t;
{
#if 0
    if (!side->designer) {
	cmd_error(side, "No permission to alter connections!");
    } else if (numcntypes <= 0) {
	cmd_error(side, "No connection types to paint!");
    } else {
	if (!area.connections) allocate_area_connections();
	tmpside = side;
	tmpttype = t;
    }
#endif
}
#endif /* DESIGNERS */

/* The "beep trigger" is to be set only after an explicit command (should
   be per-side, ahem), controls whether a command error is noisy or not. */

int beeptrigger = FALSE;

/* Generic command error routine. */

/*VARARGS*/
cmd_error(side, control, a1, a2, a3, a4, a5, a6)
Side *side;
char *control, *a1, *a2, *a3, *a4, *a5, *a6;
{
    notify(side, control, a1, a2, a3, a4, a5, a6);
    /* Make irritating noise only when a human player both wants and
       deserves it. */
    if (active_display(side) && 1 /* humanside(side) */ && beeptrigger) {
	beep(side);
    }
}

/* The handler for unit production needs to make sure valid input has
   been received, will put in another request if not. */

x_product_type(side)
Side *side;
{
    int u;
    Unit *unit = selected_unit(side);

    if ((u = grok_unit_type(side)) >= 0) {
#if 0
	unit->action.type = A_BUILD;
	unit->action.ac1 = u;
	unit->action.ac2 = unit->x;  unit->action.ac3 = unit->y;
	/* (how do we know we can do an action right now?) */
	/* (check actionsleft?) */
	execute_action(unit);
#endif
    } else {
	request_input(side, x_product_type);
    }
}

/* This is called when production is to be set or changed.  Note that since
   the user has a pretty dull choice if there is only one possible type of
   unit to build, in such cases we can bypass requests altogether.  Also,
   don't start over if the requested unit is what was already under
   construction. */

request_new_product(unit)
Unit *unit;
{
#if 0
    int u, uvec[MAXUTYPES];
    Side *us = unit->side;

    if (1 /* humanside(us) */) {
	/* (bring up a unit closeup maybe?) */
	for_all_unit_types(u) uvec[u] = uu_make(unit->type, u);
	sprintf(spbuf, "%s will build: ", unit_handle(us, unit));
	u = ask_unit_type(us, spbuf, uvec);
	/* If we didn't get a good type, ask again. */
	if (u < 0) {
/*	    us->ui->requnit = unit;  */
	    request_input(us, x_product_type);
	} else {
	    /* If something already underway, abandon if diff type */
	    if (unit->build != NULL && unit->build->type == u) {
		notify(us, "Already building a %s, continuing",
		       u_type_name(u));
	    } else {
		/* (need explicit cancel of prev build?) */
		/* Set up the build action. */
		unit->action.type = A_BUILD;
		unit->action.ac1 = u;
		unit->action.ac2 = unit->x;  unit->action.ac3 = unit->y;
		/* Do the action (but only if actionsleft sufficient) */
		execute_action(unit);
	    }
	}
    } else {
	/* machine version? */
    }
#endif
}

/* Just need to remember planned build. */

x_next_product_type(side)
Side *side;
{
#if 0
    int u;

    if ((u = grok_unit_type(side)) >= 0) {
	if (u != NONUTYPE) {
	    selected_unit(side)->plan->nextbuild = u;
	}
    } else {
	request_input(side, x_next_product_type);
    }
#endif
}

/* This is called when production is to be set or changed.  This
   routine allows the user to specify what will be produced after the
   current production is finished. */

request_next_product(unit)
Unit *unit;
{
#if 0
    int u, uvec[MAXUTYPES];
    Side *us = unit->side;

    if (1 /* humanside(us) */) {
	for_all_unit_types(u) uvec[u] = uu_make(unit->type, u);
	sprintf(spbuf, "%s's next build will be: ", unit_handle(us, unit));
	u = ask_unit_type(us, spbuf, uvec);
	if (u < 0) {
/*	    us->ui->requnit = unit;  */
	    request_input(us, x_next_product_type);
	} else {
	    /* what to do here? */
	}
    } else {
       /* the machine should never do this.  Just ignore it.  */
    }
#endif
}

do_finished(side, n)
Side *side;
int n;
{
    finish_turn(side);
}

/* Center the screen on the current location. */

do_recenter(side, map, x, y)
Side *side;
Map *map;
int x, y;
{
    if (map != NULL) {
	recenter(side, map, x, y);
    } else {
	cmd_error(side, "No map!");
    }
}

/* This command provides a short note about the current hex.  It just
   interprets what is already visible, doesn't supply any additional info. */

do_ident(side, map, x, y)
Side *side;
int /* Map * */ map;
int x, y;
{
#if 0
    int anylinear;
    viewdata view = side_view(side, x, y);
    char t = terrain_at(x, y), d;
    Side *side2;

    if (view == UNSEEN) {
	notify(side, "You see unexplored territory");
    } else {
	if (view == EMPTY) {
	    sprintf(spbuf, "You see unoccupied %s", t_type_name(t));
	} else {
	    sprintf(spbuf, "You see ");
	    side2 = side_n(vside(view));
	    if (side == side2) {
		sprintf(spbuf+strlen(spbuf), "one of your %s",
			plural_form(u_type_name(vtype(view))));
	    } else {
		sprintf(spbuf+strlen(spbuf), "a %s %s",
			(side2 == NULL ? "independent" : side2->name),
			/* identify enemy/ally too? */
			u_type_name(vtype(view)));
	    }
	    sprintf(spbuf+strlen(spbuf), " (in the %s)", t_type_name(t));
	    /* (Display unit name too if known) */
#ifdef LINEAR
	}
	if (borders_defined()) {
	    anylinear = FALSE;
	    for_all_directions(d) {
		if (border_at(x, y, d) != NOBORDER) {
		    if (!anylinear) {
			sprintf(spbuf+strlen(spbuf),
				", %s to the", t_type_name(thebordertype));
			anylinear = TRUE;
		    }
		    sprintf(spbuf+strlen(spbuf), " %s", dirnames[d]);
		}
	    }
	}
	if (connections_defined()) {
	    anylinear = FALSE;
	    for_all_directions(d) {
		if (connection_at(x, y, d) != NOCONNECTION) {
		    if (!anylinear) {
			sprintf(spbuf+strlen(spbuf),
				", %s leading",
				t_type_name(theconnectiontype));
			anylinear = TRUE;
		    }
		    sprintf(spbuf+strlen(spbuf), " %s", dirnames[d]);
		}
	    }
	}
#endif /* LINEAR */
	/* should mention named geo feature too */
	notify(side, spbuf);
    }
#endif
}

/* Add something here when there are something like "commands". */

describe_commands(arg, key, buf)
int arg;
char *key, *buf;
{
}

/* The following structure is used only for the dispatch table. */

typedef struct func_tab {
    char *fchar;                 /* character to match against */
    int (*code)();              /* pointer to command's function */
    int defaultarg;             /* default for argument */
    short needunit;              /* true if cmd always applies to a unit */
    char *help;                 /* short documentation string */
} FuncTab;

/* Predeclarations of all commands. */

/* The command table itself.  Default iterations of ITERFLAG actually turn */
/* into the value of "itertime", which can be set by options cmd. */

FuncTab commands[] = {
    "s", do_sentry, ITERFLAG, TRUE, "put a unit on sentry duty",
    "w", do_wakemain, 0, FALSE, "wake units up from whatever they were doing",
    " ", do_sit, 1, FALSE, "(Space Bar) make unit be on sentry this turn only",
    "r", do_return, 1, TRUE, "return unit to nearest city/transport",
    "d", do_delay, 1, TRUE, "delay unit's move until later in turn",
    "f", do_follow, ITERFLAG, TRUE, "follow a designated leader",
    "m", do_moveto, 1, TRUE, "move to given location",
    "a", do_occupant, 1, TRUE, "look at the occupants",
    "e", do_embark, 0, TRUE, "embark units onto transport occupying same unit",
    "x", do_mark_unit, 1, TRUE, "mark unit for later reference",
    "g", do_give, -1, TRUE, "give supplies to the transport",
    "t", do_take, -1, TRUE, "take supplies from the transport",
    "p", do_pause, 1, FALSE, "pause the game",
    " ", NULL, 0, 0, "",
    "P", do_build, 0, FALSE, "set/change unit production",
    "I", do_idle, ITERFLAG, TRUE, "set unit to not produce anything",
    "W", do_wakeup, 0, FALSE, "wake ALL units in area, including occupants",
    "F", do_coast, ITERFLAG, TRUE, "follow a coastline",
    "Z", do_patrol, ITERFLAG, TRUE, "go on a patrol",
    "G", do_give_unit, -2, TRUE, "turn unit over to another side",
    "M", do_message, -2, FALSE, "send a message to other sides",
    "X", do_resign, -2, FALSE, "resign from the game",
    "Q", do_exit, 1, FALSE, "kill game for all players",
/*    "A", do_add_player, 1, FALSE, "add a new player to the game", */
    "C", do_name, 1, FALSE, "call a unit or side by a name",
    "/", do_ident, 1, 2, "identify things on screen",
/*    "=", do_unit_info, 1, FALSE, "display details about a type of unit",  */
    "\r", do_finished, 1, FALSE, "declare turn to be finished",
    "\001", do_auto, 1, TRUE, "Turn unit over to machine control",
    "\020", do_next_product, 1, TRUE, "set next product",
    "\006", do_find_next_mover, -1, FALSE, "find next unit to move",
    "\002", do_find_prev_mover, -1, FALSE, "find prev unit to move",
    "\006", do_look, -1, FALSE, "look at action point when not your turn",
    ".", do_recenter, 1, 2, "center the screen around current location",
    "#", do_distance, 1, FALSE, "measure the distance from the current point",
    NULL, NULL, 0, FALSE, NULL   /* end of table marker */
};

/* Just to get everything off on the right foot. */

init_requests(side)
Side *side;
{
    side->ui->reqvalue = DFLTFLAG;
}

/* Set up a modal handler - this handler will intercept input until it
   is satisfied. */

request_input(side, handler)
Side *side;
int (*handler)();
{
}

cancel_request(side)
Side *side;
{
}

#if 0

/* Acquire a command from the player.  Command may be prefixed with a */
/* nonnegative number which is given as an argument to the command function */
/* (otherwise arg defaults to value in third column of command table). */
/* This routine takes in both keyboard and mouse input, other kinds of */
/* devices should be handled here also (rriiiight...).  Don't do any of */
/* this if the clock ran out, just supply an innocuous command. */

int tmpx, tmpy;

x_command(side)
Side *side;
{
    int dir, terr, sign = 1;

    Dprintf("%s keyboard input: %c (%d)\n",
	    side->name, side->ui->reqch, side->ui->reqvalue);
    if (isdigit(side->ui->reqch)) {
	if (side->ui->reqvalue == DFLTFLAG) {
	    side->ui->reqvalue = 0;
	} else {
	    side->ui->reqvalue *= 10;
	}
	side->ui->reqvalue +=
	  (side->ui->reqvalue >= 0 ? 1 : -1) * (side->ui->reqch - '0');
	side->ui->reqvalue *= sign;
	sprintf(side->ui->promptbuf, "Arg: %d", side->ui->reqvalue);
	return;
    } else {
/*	execute_command(side, side->ui->reqch, side->ui->reqvalue); */
    }
    /* Reset the arg so we don't get confused next time around */
    side->ui->reqvalue = DFLTFLAG;
}

/* Search in command table and execute function if found, complaining if */
/* the command is not recognized.  Many commands operate on the "current */
/* unit", and all uniformly error out if there is no current unit, so put */
/* that test here.  Also fix up the arg if the value passed is one of the */
/* specially recognized ones. */

execute_command(side, ch, n)
Side *side;
char ch;
int n;
{
    struct func_tab *cmd;
    int x, y;
    Map *map;
    
    for (cmd = commands; cmd->fchar != '\0'; ++cmd) {
	if (ch == cmd->fchar) {
	    if (n == DFLTFLAG) n = cmd->defaultarg;
	    if (n == ITERFLAG) n = side->itertime;
	    Dprintf("... actual arg is %d\n", n);
	    switch (cmd->needunit) {
	      case 0:
		(*(cmd->code))(side, n);
		break;
	      case 1:
		if (sample_pointer(side, &map, &x, &y)
		    && map != NULL
		    && map->curunit != NULL) {
		    (*(cmd->code))(side, map->curunit, n);
		} else {
		    cmd_error(side, "No unit to operate on!");
		}
		break;
	      case 2:
		if (sample_pointer(side, &map, &x, &y)) {
		    (*(cmd->code))(side, map, x, y);
		} else {
		    cmd_error(side, "Not looking at a map!");
		}
	    }
	    return;
	}
    }
    cmd_error(side, "Unknown command '%c'", ch);
}
#endif

/* Find out if the pointer is over a hex on some map, fill in map and hex. */

sample_pointer(side, mapp, xp, yp)
Side *side;
Map **mapp;
int *xp, *yp;
{
    int x1, y1, x2, y2, dir;
    unsigned int mask;
    Map *map;
    Window w1, w2;

    for_all_maps(side, map) {
	/* ambiguity about "root window" here */
	if (XQueryPointer(sdd(side), map->viewwin,
			  &w1, &w2, &x1, &y1, &x2, &y2, &mask)) {
	    deform(side, map, x2, y2, xp, yp, &dir);
	    *mapp = map;
	    printf("%d,%d -> %d,%d on map 0x%x\n", x2, y2, *xp, *yp, *mapp);
	    return TRUE;
	}
    }
    return FALSE;
}

/* Help for the main command mode just dumps part of the table, and a little */
/* extra info about what's not in the table.  This may go onto a screen or */
/* into a file, depending on where this was called from. */

command_help(side)
Side *side;
{
#if 0
    FuncTab *cmd;

    wprintf(side, "  ");
    for (cmd = commands; cmd->fchar != '\0'; ++cmd) {
	if (cmd->fchar < ' ') {
	    wprintf(side, "^%c %s", ('A' + cmd->fchar - 1), cmd->help);
	} else {
	    wprintf(side, "%c  %s", cmd->fchar, cmd->help);
	}
    }
#endif
}

